#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h> 
#include <sys/stat.h> 
#include <sys/file.h>

int readSentence() {
  FILE *f;
  char line[80];
  
  if ((f=fopen("pal.in","w"))==NULL) {
    perror("fopen pal.in");
    exit(0);
  }
  while (1) {
    printf(">");
    if (scanf("%s",line)!=1) continue;
    if (!strcmp(line,"exit.")) {fclose(f); return 0;}
    if (!strcmp(line,"."))
      {fclose(f); return 1;}    
    fprintf(f,"%s\n",line);
  }
}

void printResult() {
  FILE *f;
  int c;
  
  if ((f=fopen("pal.out","r"))==NULL) {
    perror("fopen pal.out");
    exit(0);
  }
  while ((c=fgetc(f))!=EOF)
    printf("%c",c);
  fclose(f);
}

int main()
{
    int fifoin,fifoout;
    int i;
    char s[80],c=1;
    FILE *fin,*fout;


    if (mkfifo("pal.in.fifo", 0666) < 0) {
        perror("pal.in.fifo create");
        exit(1);
    }
    if (mkfifo("pal.out.fifo", 0666) < 0) {
        perror("pal.out.fifo create");
        exit(1);
    }
    if ((fifoin = open("pal.in.fifo", O_RDWR)) < 0) {
        perror("pal.out.fifo open");
        exit(1);
    }
    if ((fifoout = open("pal.out.fifo", O_RDWR)) < 0) {
        perror("pal.in.fifo open");
        exit(1);
    }
    
    if (fork()==0) {
      if (execlp("pal","pal","-a","-m","kk.pal",0) <0){
          perror("pal execution");
          exit(1);
      }
      exit(0);
    }
      
    while (readSentence()) {
      /* Send the order for parsing */
      write(fifoin,&c,1);
      /* Wait until parsed */
      read(fifoout,&c,1);
      printResult();
    }

    /* send order for stopping */
    c=0;
    write(fifoin,&c,1);
    
    close(fifoin);
    close(fifoout);
    
    if (unlink("pal.in.fifo") < 0) {
        perror("pal.in.fifo unlink");
        exit(1);
    }
    if (unlink("pal.out.fifo") < 0) {
        perror("pal.out.fifo unlink");
        exit(1);
    }

}
