#include "all.h"
/*
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <search.h>
#include "queue.h"
#include "sets.h"
#include "btree.h"
#include "binvec.h"
#include "icode.h"
*/
struct SymTable SymTables[TYPES]; 
struct SymTable SymData[TYPES];
struct SymTable TabAct,TabFlu;
struct SymTable tabRulInfo;
tRulInfo rulInf;
unsigned int yyline=1;
NUM FALSE_NSym,TRUE_NSym,BOOLEAN_NSym,EVENT_NSym;
struct Elem *BOOLEAN_RANGE;
NUM NSym;
NUM DefRangeNSym;
char DefType;
char AllowNewSVAL=0;
struct tExpNode Node;
NUM RuleCount=0;
NUM NGenRules=0;
NUM NRules=0;
QUEUE VarList=qEMPTY;
struct tVarLstNode *VarVec=NULL;
BTREE HeadExpr;
struct tFunct *HeadFunct;
BTREE CondExpr;
NUM NVars=0;
struct Elem *tup;
NUM NSol=0;
struct tGenericFunctions *GF;
char verbose=1;
QUEUE QueryList;
tQueryNode *QueryVec;
SIT Now=0;
SIT IniSit=0;
SIT ExprSit=0;
FILE *fGroundOut=NULL;
FILE *fTxtProgram=NULL;
int UsePipes=0;
unsigned pal_code=errNONE;
char pal_errmsg[80];
char UsingSafeOps=0;
unsigned ShiftSit=0; /* used for ExprCopy/FunctCopy/TupleCopy */

int OptVal[NOPT]={0,1,1,0,0,0};
static char *txtOpt[]=
  {"solutions","concurrent","unknown","warnings","inference","mute"};
static char *txtSolutions[] = {"all"};
static char *txtOnOff[] = {"off","on"};
static char *txtInference[] = {"wellfounded","medtool","smodels","fitting"};

static char **txtOptVal[] = 
  {txtSolutions,txtOnOff,txtOnOff,txtOnOff,txtInference,txtOnOff};
static char OptNumVal[]={1,2,2,2,4,2};  

tQueryNode *pQNode=NULL;

static NUM NVar;
static char HasVars=0;

static QUEUE stack=qEMPTY;

void EvalExpr(BTREE);




void stInit(struct SymTable *st)
{
  st->NBlocks=0;
  st->NSym=0;
  st->Table=NULL;
  st->CurBlock=NULL;
}

int stNewBlock(struct SymTable *st)
{
  char ***Aux;
  
  st->NBlocks++;
  if ((Aux=(char ***)calloc(st->NBlocks,sizeof(char **)))==NULL) return 0;
  if (st->NBlocks>1) {
    memcpy(Aux,st->Table,sizeof(char **)*(st->NBlocks-1));
    free(st->Table);
  }
  st->Table=Aux;
  if ((st->CurBlock=(char **)calloc(BLOCKSIZE,sizeof(char *)))==NULL) return 0;
  st->Table[st->NBlocks-1]=st->CurBlock;
  return 1;
}

NUM stAddSym(struct SymTable *st,char *s)
{
  if (st->NSym%BLOCKSIZE==0)
    stNewBlock(st);
  st->CurBlock[st->NSym%BLOCKSIZE]=s;
  return st->NSym++;
}

void stFree(struct SymTable *st)
{
  int i,j;
  if (st->NSym) {
    for(i=0;i<st->NBlocks;i++)
    {
      for(j=0;j<BLOCKSIZE;j++)
        if(st->Table[i][j]) free(st->Table[i][j]);
      free(st->Table[i]);
    }
    free(st->Table);
  }
  stInit(st);
}

int GetNSym(char *s,int type,NUM *NSym)
{
  ENTRY e,*pe;
  char *r;
  
  r=strCopy(s);
  e.key=r;
  pe=hsearch(e,FIND);
  if (pe==NULL) {
    if (type==-1) return -1; 
    e.data=(char *)malloc(sizeof(struct Elem));
    ((struct Elem *)e.data)->Type=type;
    *NSym=((struct Elem *)e.data)->N.Sym=stAddSym(&SymTables[type],r);
    stAddSym(&SymData[SVALUE],(char *)e.data);
    hsearch(e,ENTER); 
    return -1;
  }
  else {
    free(r);
    *NSym=((struct Elem *)(pe->data))->N.Sym;
    return ((struct Elem *)(pe->data))->Type;
  }
}

char *strCopy(char *s)
{
  int size;
  char *t;
  
  size=strlen(s)+1;
  if( (t=(char *)malloc(sizeof(char)*size)) == NULL)
  {
    printf("NULL malloc: cloning string %s\n",s);
    exit(0);
  }
  memcpy(t,s,size);
  return t;
}

char *strAppend(char *s,char *t)
{
  char *r=(char *)malloc(strlen(s)+strlen(t)+1);
  sprintf(r,"%s%s",s,t);
  free(s);
  return r;
}

void GenAtoms(struct tFunctHeader *pfh,NUM FunctCode,char Type)
{
  struct tAtom *a;
  struct SymTable *AtomsTable;
  NUM i,*Cards,*Comb;
  struct Elem **ArrDomain;
  char *types;
  QUEUE qAux;
  
  switch (Type) {
    case ACTION: AtomsTable=&TabAct; break;
    case FLUENT: AtomsTable=&TabFlu; break;
  }
  
  pfh->BaseNSym=AtomsTable->NSym;
  if (pfh->Domain==qEMPTY) {
    a=(struct tAtom *)malloc(sizeof(struct tAtom));
    a->NSym=FunctCode;
    a->pcktuple=NULL;
    a->pfh=pfh;    
    switch (Type) {
      case ACTION: stAddSym(&TabAct,(char *)a); break;
      case FLUENT: stAddSym(&TabFlu,(char *)a); break;
    }
    GF->InitAtom(a,Type);
    pfh->NTuples=1;
  }  
  else {
    ArrDomain=(struct Elem **)malloc(pfh->Arity*sizeof(struct Elem *));
    Cards=(NUM*)malloc(pfh->Arity*sizeof(NUM));
    Comb=(NUM*)calloc(pfh->Arity,sizeof(NUM));

    qAux=pfh->Domain;
    for(i=0;i<pfh->Arity;i++) {
      ArrDomain[i]=(struct Elem *)Queue2Array(*qFirst(qAux,QUEUE),
                    sizeof(struct Elem),&Cards[i]);
      qAux=qAux->next;		   
    }
    
    pfh->NTuples=1;
    for(i=0;i<pfh->Arity;i++) pfh->NTuples*=Cards[i];
    if (pfh->NTuples)    
      do {
	/* Create new atom */
	a=(struct tAtom *)malloc(sizeof(struct tAtom));
	a->NSym=FunctCode;
	a->pfh=pfh;

	/* Create tuple */
	a->pcktuple=(char *)malloc((sizeof(ELMVAL)+sizeof(char))*pfh->Arity);
	types=a->pcktuple+sizeof(ELMVAL)*pfh->Arity;
	for (i=0;i<pfh->Arity;i++) {  
	  memcpy(a->pcktuple+i*sizeof(ELMVAL),&ArrDomain[i][Comb[i]].N,
		 sizeof(ELMVAL));
	  types[i]=ArrDomain[i][Comb[i]].Type;
	}
	/* Add atom to Table */
	switch (Type) {
	  case ACTION: stAddSym(&TabAct,(char *)a); break;
	  case FLUENT: stAddSym(&TabFlu,(char *)a); break;
	}
	GF->InitAtom(a,Type);    
      } while (NextComb(Comb,Cards,pfh->Arity));		
    free(Comb);
    free(Cards);
    free(ArrDomain);
  }
}


void ComputeOp(char op,struct tExpNode *x,struct tExpNode *y)
{
  char s[2]="x";
  
  /* Unary operators */
  if (x==NULL) {  
    switch(op) {
      case '': 
        if (!(y->Type==SVALUE && y->d.Sym<=TRUE_NSym)) 
	  SemError("invalid operand type for `not'.\n",NULL);
	y->d.Sym = !y->d.Sym;
	break;
      case 'm':
        if (y->Type!=NVALUE) 
	  SemError("invalid operand type for `-'.\n",NULL);
	y->d.Val = -y->d.Val;
	break;
      case 'a':
        if (y->Type!=NVALUE) 
	  SemError("invalid operand type for '| ... |'.\n",NULL);
	y->d.Val = labs(y->d.Val);
    }  
    return;
  }

  /* Binary integer operators */
  if (strchr("+-*/%><gl",op)) {
    if (x->Type!=NVALUE || y->Type!=NVALUE)
      { s[0]=op; SemError("invalid operand type `%s'.\n",s);}

    switch(op) {
      case '+': y->d.Val = x->d.Val + y->d.Val; return;
      case '-': y->d.Val = x->d.Val - y->d.Val; return;
      case '*': y->d.Val = x->d.Val * y->d.Val; return;
      case '/': y->d.Val = x->d.Val / y->d.Val; return;
      case '%': y->d.Val = x->d.Val % y->d.Val; return;
      
      case '>': y->d.Sym = x->d.Val > y->d.Val; break;
      case '<': y->d.Sym = x->d.Val < y->d.Val; break;
      case 'g': y->d.Sym = x->d.Val >= y->d.Val; break;
      case 'l': y->d.Sym = x->d.Val <= y->d.Val; break;
    }
    y->Type=SVALUE;
    y->isPert |= x->isPert;
    return;
  }

  /* Equality/inequality */
  if (strchr("=n",op)) {    
    switch(op) {
      case '=': 
        if (x->Type!=y->Type) 
	  y->d.Sym=FALSE_NSym;
	else
          if (x->Type==NVALUE)
            y->d.Sym = (y->d.Val == x->d.Val);
	  else
            y->d.Sym = (y->d.Sym == x->d.Sym);
	break;
      case 'n':
        if (x->Type!=y->Type) 
	  y->d.Sym=TRUE_NSym;
	else
          if (x->Type==NVALUE)
            y->d.Sym = (y->d.Val != x->d.Val);
	  else
            y->d.Sym = (y->d.Sym != x->d.Sym);
	break;
    }
    y->Type=SVALUE;
    y->isPert |= x->isPert;
    return;
  }
  
  /* Binary Logical Operators */
  if (strchr("^v&|",op)) {
    if (x->Type!=SVALUE || x->d.Sym>TRUE_NSym || 
        y->Type!=SVALUE || y->d.Sym>TRUE_NSym)
      { s[0]=op; SemError("invalid operand type `%s'.\n",s);}
      
    switch(op) {
      case '^': 
        y->isPert |= x->isPert;
        y->d.Sym &= x->d.Sym; 
	break;
      case '&':        
        y->isPert = (x->isPert && y->isPert) || (x->isPert && y->d.Sym) || (y->isPert && x->d.Sym);
        y->d.Sym &= x->d.Sym; 
	break;
      case 'v': 
        y->isPert |= x->isPert;
        y->d.Sym |= x->d.Sym; 
	break;
      case '|':
        y->isPert = (x->isPert && y->isPert) || (x->isPert && !y->d.Sym) || (y->isPert && !x->d.Sym);
        y->d.Sym |= x->d.Sym; 
	break;
    }
  }
}


void DecideOp(BTREE *e,BTREE *e1,BTREE *e2,char op)
{
  if (e1==NULL) {
    if (Root(*e2).Type==NVALUE || Root(*e2).Type==SVALUE) {
      ComputeOp(op,NULL,&Root(*e2));
      *e=*e2;
      return;
    }
    
    Node.Type=OPER;
    Node.d.Op=op;
    *e=Tree(&Node,NULL,*e2);
    return;
  }

  if ((Root(*e1).Type==NVALUE || Root(*e1).Type==SVALUE) &&
      (Root(*e2).Type==NVALUE || Root(*e2).Type==SVALUE)) {
    ComputeOp(op,&Root(*e1),&Root(*e2));
    btFree(e1);
    *e=*e2;
    return;
  }
  
  Node.Type=OPER;
  Node.d.Op=op;
  *e=Tree(&Node,*e1,*e2);
}


int InsertNewVar(QUEUE *pVList,char Type,NUM NSym,struct tFunct *pf)
{
  struct tVarLstNode VNode;

  if ((VNode.Type=Type)==VAR) 
    VNode.d.Sym=NSym;
  else
    VNode.d.Funct=pf;
        
  NVar=0;

  if (qBrowse(*pVList,eqVarLstElm,&VNode)!=NULL) return --NVar;
  
  qInsertLast(pVList,&VNode,sizeof(VNode));
  return NVars++;
}

void DecideFunct(char *name,char Modifier,SIT Sit,QUEUE params,BTREE *pexp)
{ 
  int type;
    
  switch(type=GetNSym(name,-1,&NSym)){
    case ACTION:
    case FLUENT:
      Node.Type=type;
      Node.d.Funct=(struct tFunct*)malloc(sizeof(struct tFunct));
      Node.d.Funct->Type=type;
      Node.d.Funct->NSym=NSym;
      Node.d.Funct->Modifier=Modifier;
      Node.d.Funct->Sit=Sit;
      Node.d.Funct->Tuple=params;
      if (qCount(params)!=
          ((struct tFunctHeader *)stEntry(SymData[type],NSym))->Arity)
      {
        printf("%d: ",yyline); 
	printf("%s `%s' has been defined as %d-ary\n",
	  (type==ACTION)?"action":"fluent",
	   stEntry(SymTables[type],NSym),
	   ((struct tFunctHeader *)stEntry(SymData[type],NSym))->Arity
	   ); 
	exit(1);
      }
      break;
    case -1:
      if (AllowNewSVAL && params==NULL && Modifier==modNONE && Sit==0) {
	Node.Type=SVALUE;
	GetNSym(name,SVALUE,&Node.d.Sym);
	*pexp=Leaf(&Node);
	return;
      }      
      else
        SemError("`%s' undefined.\n",name);
      break;
    case CONSTANT:
      if (params==NULL && Modifier==modNONE) {
	struct Elem *pe;
	pe=(struct Elem*)stEntry(SymData[CONSTANT],NSym);
	Node.Type=pe->Type;
	if (pe->Type==NVALUE)
	  Node.d.Val=pe->N.Val;
	else
	  Node.d.Sym=pe->N.Sym;
	*pexp=Leaf(&Node);
	return;
      }      
      else
        SemError("`%s' action or fluent expected.\n",name);
      break;
    case SVALUE:
      if (params==NULL && Modifier==modNONE) {
	Node.Type=SVALUE;
	Node.d.Sym=NSym;
	*pexp=Leaf(&Node);
	return;
      }      
      else
        SemError("`%s' action or fluent expected.\n",name);
      break;
    default:
      SemError("`%s' action or fluent expected.\n",name);
  }
  Node.Type=VAR;
  Node.d.Sym=InsertNewVar(&VarList,type,0,Node.d.Funct);
  *pexp=Leaf(&Node);
  free(name);
}

/* Used for FreeFunct */

int FreeTuple(QUEUE tuple,void *d)
{
  btFree(qFirst(tuple,BTREE));
  return 0;
}

int FreeFunct(struct tFunct *pf)
{
  if (pf==NULL) return 1;
  if (qIsNotEmpty(pf->Tuple))
    qBrowse(pf->Tuple,FreeTuple,NULL);
  qFree(&pf->Tuple);
  free(pf);
  return 0;
}

int eqExp(BTREE t1,BTREE t2)
{
  if (t1==t2) return 1;
  if (t1==NULL || t2==NULL) return 0;
  if (Root(t1).Type!=Root(t2).Type) return 0;
  
  switch(Root(t1).Type) {
    case NVALUE: 
      return Root(t1).d.Val==Root(t2).d.Val;
    case SVALUE:
    case VAR:
      return Root(t1).d.Sym==Root(t2).d.Sym;
    case OPER:
      if (Root(t1).d.Op!=Root(t2).d.Op) return 0;
      return eqExp(t1->left,t2->left) && eqExp(t1->right,t2->right);
/*
    case ACTION:
    case FLUENT:  
    They have been replaced by VARs
*/
  }
  return 0;
}


int eqFunct(struct tFunct *pf1,struct tFunct *pf2)
{
  QUEUE t1old,t2old,tn1old,tn2old;
  int cmp=1;

  if (pf1->NSym!=pf2->NSym) return 0;
  if (pf1->Type!=pf2->Type) return 0;
  if (pf1->Modifier!=pf2->Modifier) return 0;
  if (pf1->Sit!=pf2->Sit) return 0;

  /* The functor is the same one, check the tuples  */
  /* (both tuples are expected to be of same length */

  if (pf1->Tuple!=NULL)
  {  
    /* Break the round links and browse both tuples */
    BREAKLINK(pf1->Tuple,t1old,tn1old);
    BREAKLINK(pf2->Tuple,t2old,tn2old);

    while (pf1->Tuple!=NULL && cmp)
    {
       cmp=eqExp(*(BTREE *)pf1->Tuple->data,*(BTREE *)pf2->Tuple->data);
       pf1->Tuple=pf1->Tuple->next;
       pf2->Tuple=pf2->Tuple->next;
    }

    /* Restore round links */
    pf1->Tuple=t1old; pf1->Tuple->next=tn1old;
    pf2->Tuple=t2old; pf2->Tuple->next=tn2old;
  }

  return cmp;
}

int eqVarLstElm(QUEUE q,void *p2)
{
  int cmp;
  struct tVarLstNode *pn1,*pn2;

  NVar++;
  pn1=qFirst(q,struct tVarLstNode);
  pn2=(struct tVarLstNode *)p2;

  if (pn1->Type!=pn2->Type) return 0;

  if (pn1->Type==VAR)
    return pn1->d.Sym==pn2->d.Sym;

  if (pn1->d.Funct==pn2->d.Funct) return 1;
  if ((cmp=eqFunct(pn1->d.Funct,pn2->d.Funct)))
  {
    FreeFunct(pn2->d.Funct);
    pn2->d.Funct=pn1->d.Funct;
  }

  return cmp;
}

void AddVarRange(struct tVarLstNode *VarVec,struct Elem **ranges,
                 NUM * Cards,NUM i)
{
  struct tVarLstNode *pn=VarVec+i;
  struct tVar *pv;

  if (pn->Type==VAR)
  {
    pv=(struct tVar *)stEntry(SymData[VAR],VarVec[i].d.Sym);
    ranges[i]=pv->Range;
    Cards[i]=pv->RangeSize;
  }
  else {
    if (pn->d.Funct->Modifier==modPERT) {
      ranges[i]=BOOLEAN_RANGE;
      Cards[i]=2;
    }
    else {
      struct tFunctHeader *pfh;
      pfh=(struct tFunctHeader *)stEntry(SymData[pn->d.Funct->Type],
                                       pn->d.Funct->NSym);
      ranges[i]=pfh->Range;
      Cards[i]=pfh->RangeSize;
    }
  }
}

int GetArgsPertinenceInTuple(QUEUE tuple,void *d)
{
  struct tExpNode Node;

  EvalExpr(*qFirst(tuple,BTREE));
  memcpy(&Node,qFirst(stack,struct tExpNode),sizeof(struct tExpNode));
  qPOP(&stack,&Node,struct tExpNode);
  /* we leave the rest of the stack untouched */

  return Node.isPert; /* it stops when some argument is pertinent */
}


int GetPertinenceInTuple(NUM i) {
  struct tFunct *pf;
  NUM n;
  
  /* a variable is never pertinent: it is instantiated by a constant value */
  if (VarVec[i].Type==VAR) return 0;

  /* if found some pertinent argument, then return pertinent */
  if (qBrowse(VarVec[i].d.Funct->Tuple,GetArgsPertinenceInTuple,NULL) != NULL)
    return 1;
      
  /* a reference to pert(x) is pertinent iff it is true */
  if (VarVec[i].d.Funct->Modifier==modPERT) return tup[i].N.Sym==TRUE_NSym;

  /* a reference to an action (without pert modifier) is always pertinent */
  if (VarVec[i].Type==ACTION) return 1;
  
  /* Otherwise, we have a fluent */
  
  /* we search its pertinence in VarList */
  pf=FunctCopy(VarVec[i].d.Funct);
  pf->Modifier=modPERT;
  /* Get the funct number (it can't be a new var) */
  n=InsertNewVar(&VarList,FLUENT,0,pf);
  /* nsertNewVar executes FreeFunct(pf) when the funct already existed */
  return tup[n].N.Sym==TRUE_NSym;
}

void EvalExpr(BTREE e)
{
  if (e==NULL) return;
  
  EvalExpr(e->left);
  EvalExpr(e->right);

  switch(Root(e).Type) {
    case NVALUE:
    case SVALUE:
      Root(e).isPert=0;
      qPUSH(&stack,&Root(e),struct tExpNode); 
      return;
    case VAR:
      if (UsingSafeOps)
        Node.isPert=GetPertinenceInTuple(Root(e).d.Sym);
      Node.Type=tup[Root(e).d.Sym].Type;
      if (Node.Type==NVALUE)
        Node.d.Val=tup[Root(e).d.Sym].N.Val;
      else
        Node.d.Sym=tup[Root(e).d.Sym].N.Sym;
      qPUSH(&stack,&Node,struct tExpNode); 
      return;
    case OPER:
    { struct tExpNode Node2,*pn;
    
      qPOP(&stack,&Node2,struct tExpNode);
      if (strchr("+-*/%^v&|><gl=n",Root(e).d.Op)) {
        qPOP(&stack,&Node,struct tExpNode);
	pn=&Node;
      }
      else
        pn=NULL;
      ComputeOp(Root(e).d.Op,pn,&Node2);
      qPUSH(&stack,&Node2,struct tExpNode); 
      return;      
    }
  }  
}

void Eval(BTREE e,struct tExpNode *result)
{
  stack=qEMPTY;
  EvalExpr(e);
  memcpy(result,qFirst(stack,struct tExpNode),sizeof(struct tExpNode));
  qFree(&stack);  
}


NUM GetAtomNum(struct tFunct *pf)
#define ATOMTUPLE(i) (((struct tAtom *)stEntry(*AtomsTable,i))->pcktuple)
{
  double l,r;
  NUM m;
  unsigned j;
  char *pcktuple,*types;
  unsigned tuplesize;
  struct tFunctHeader *pfh;
  int cmp;
  QUEUE exprTuple;
  struct SymTable *AtomsTable;
  
  pal_code=errNONE;
  
  switch (pf->Type) {
    case ACTION: AtomsTable=&TabAct; break;
    case FLUENT: AtomsTable=&TabFlu; break;
  }
  
  pfh=(struct tFunctHeader *)stEntry(SymData[pf->Type],pf->NSym);
  l=pfh->BaseNSym;
  if (pfh->Arity==0) return (NUM)l;
  r=(double)pfh->BaseNSym+(double)pfh->NTuples-1;
  
  /* Prepare packed tuple for atom search */
  tuplesize=(sizeof(ELMVAL)+sizeof(char))*pfh->Arity;
  pcktuple=(char *)malloc(tuplesize);
  types=pcktuple+sizeof(ELMVAL)*pfh->Arity;
  exprTuple=pf->Tuple;
  for (j=0;j<pfh->Arity;j++) {
    Eval(*qFirst(exprTuple,BTREE),&Node);
    if ((types[j]=Node.Type)==NVALUE)
      memcpy(pcktuple+sizeof(ELMVAL)*j,&Node.d.Val,sizeof(int));
    else
      memcpy(pcktuple+sizeof(ELMVAL)*j,&Node.d.Sym,sizeof(NUM));
    exprTuple=exprTuple->next;
  }

  /* binary search */
  while (l<=r) {
    m=(NUM)((l+r)/2.0);
    cmp=memcmp(pcktuple,ATOMTUPLE(m),tuplesize);
    if (cmp>0) l=(double)m+1;
    else 
      if (cmp<0) r=(double)m-1;
      else {free(pcktuple);return m;}
  }
  
/*  for (m=(NUM)l;m<=(NUM)r;m++)
    if (memcmp(pcktuple,ATOMTUPLE(m),tuplesize)==0) return m;  */

  pal_code=errBAD_ATOM_ARG;
  
  sprintf(pal_errmsg,"invalid argument value for %s `%s'.",
    (pf->Type==ACTION)?"action":"fluent",stEntry(SymTables[pf->Type],pf->NSym)); 
/*  exit(1);*/
}


int GetValueNum(struct tFunct *pf,struct Elem *e,NUM *Num)
{
  double l,r;
  NUM m;
  struct tFunctHeader *pfh;
  unsigned j;
  int cmp;

  pfh=(struct tFunctHeader *)stEntry(SymData[pf->Type],pf->NSym);
  l=0;
  r=(double)pfh->RangeSize-1;
    
  while (l<=r) {
    m=(NUM)((l+r)/2.0);
    cmp=setCMP((void *)e,(void *)&pfh->Range[m]);
    if (cmp>0) l=(double)m+1;
    else 
      if (cmp<0) r=(double)m-1;
      else {*Num=m; return 1;}
  }

  return 0;
}

char ExprIsTrue(BTREE Cond) 
{
  struct tExpNode Node;

  Eval(Cond,&Node);
  if (Node.Type!=SVALUE || Node.d.Sym>TRUE_NSym) {
    printf("%d: ",yyline); 
    printf("non-boolean condition.\n");
    exit(0);
  }

  return Node.d.Sym==TRUE_NSym;
}

void GenRule()
{    
  NUM i;
  struct tExpNode Node;  
  char isPert=0;

  /* Check when the ground rule must be finally generated */
  if (CondExpr!=NULL) {
    Eval(CondExpr,&Node);
    if (Node.Type!=SVALUE || Node.d.Sym>TRUE_NSym) {
      printf("%d: ",yyline); 
      printf("non-boolean condition.\n");
      exit(0);
    }
    if (Node.d.Sym!=TRUE_NSym) return; /* if the condition is false, we don't have rule */
    isPert |= Node.isPert;
  }
  
  if (UsingSafeOps) {
    if (HeadExpr!=NULL) {
      Eval(HeadExpr,&Node);
      isPert |= Node.isPert;  
    }
    if (!isPert) return; /* when using safe ops, some expression must be pertinent */
  }

  /* generate a ground rule */

  GF->TreatRule(); 
  if (pal_code!=errBAD_ATOM_ARG) {
    if (fGroundOut) WriteGroundRule(NVars); 
    NGenRules++; 
    NRules++;
  }
}

char HasSafeOps(BTREE e)
{
  if (e==NULL) return 0;
  if (Root(e).Type!=OPER) return 0;
  if (strchr("&|",Root(e).d.Op)) return 1;
  return HasSafeOps(e->left) || HasSafeOps(e->right);
}


void GenRules()
{
  struct Elem **ranges;
  NUM *Cards,*Comb;
  unsigned int i;
  
  UsingSafeOps=HasSafeOps(HeadExpr)||HasSafeOps(CondExpr);
  VarVec=NULL;
  
  #ifdef DEBUG
  if (HeadFunct==NULL) printf("false");
  else {
    showFunct(HeadFunct);
    if (HeadExpr!=NULL)
      {printf(":"); showTree(HeadExpr);}
  }
  if (CondExpr!=NULL) {printf(" if ");showTree(CondExpr);}
  printf("%s\n",(UsingSafeOps)?"[using safe ops]":"");
  #endif
  
  /* If no Vars, nothing is pertinent!. The rule is never applicable */
  if (!NVars) { 
    if(OptVal[optWARNINGS]) 
      printf("Warning: rule %d never becomes pertinent.\n",RuleCount); 
    goto GenRules_EXIT;
    return;
  }

  /* when using safe ops., vary pertinence for fluents too */
  if (UsingSafeOps) { 
    int n=NVars;
    struct tFunct *pf;

    VarVec=(struct tVarLstNode *)Queue2Array(VarList,sizeof(struct tVarLstNode),&i);
    for (i=0;i<n;i++)
      if (VarVec[i].Type==FLUENT) {
	ShiftSit=0;
	pf=FunctCopy(VarVec[i].d.Funct);
	pf->Modifier=modPERT;
        InsertNewVar(&VarList,FLUENT,0,pf);
      }      
    free(VarVec);
  }
  
  /* Transform VarList in a vector VarVec */
  VarVec=(struct tVarLstNode *)Queue2Array(VarList,sizeof(struct tVarLstNode),&i);

  /* If no fluents or actions, the rule is never pertinent */
  for (i=0;i<NVars && VarVec[i].Type==VAR;i++);
  if (i==NVars) { 
    if(OptVal[optWARNINGS]) 
      printf("Warning: rule %d never becomes pertinent.\n",RuleCount); 
    goto GenRules_EXIT;
  }

  /* Store Ranges */
  ranges=(struct Elem **)malloc(NVars*sizeof(struct Elem *));  
  Cards=(NUM*)malloc(NVars*sizeof(NUM));
  Comb=(NUM*)calloc(NVars,sizeof(NUM));
  tup=(struct Elem*)malloc(NVars*sizeof(struct Elem));
  
  for (i=0;i<NVars;i++)
    AddVarRange(VarVec,ranges,Cards,i);

  do {
    for (i=0;i<NVars;i++)
      memcpy(&tup[i],&ranges[i][Comb[i]],sizeof(struct Elem));
    GenRule();
  } while (NextComb(Comb,Cards,NVars));

  free(ranges);
  free(Comb);
  free(Cards);
  free(tup);

GenRules_EXIT:
  
  UsingSafeOps=0;
  qFree(&VarList);  
  if (VarVec) {
    for (i=0;i<NVars;i++)
      if (VarVec[i].Type!=VAR)
	FreeFunct(VarVec[i].d.Funct);
    free(VarVec);
  }
  if (CondExpr!=NULL) btFree(&CondExpr);
  if (HeadExpr!=NULL) btFree(&HeadExpr);
}

void RetrieveHead() 
{
  QUEUE VarList2=qEMPTY;
  struct tVarLstNode VNode;
  
  while (qIsNotEmpty(VarList)) {
    memcpy(&VNode,qFirst(VarList,struct tVarLstNode),sizeof(VNode));
    qDeleteFirst(&VarList);
    if (qIsEmpty(VarList))
      HeadFunct=VNode.d.Funct;
    else
      qInsertLast(&VarList2,&VNode,sizeof(VNode));
  }
  --NVars;
  VarList=VarList2;
}

int GenGround(int (*whattodo)())
{
  if (CondExpr==NULL || ExprIsTrue(CondExpr))
    if (!whattodo()) return 0;
  return 1;
}

int TreatInit()
{
  struct tExpNode Node;
  struct Elem e;
  NUM n,a;

  if (! (HeadFunct->Type==FLUENT 
         && HeadFunct->Modifier==modNONE
         && HeadFunct->Sit==0) ) {
    printf("%d: initial values can only be specified for fluents.\n",yyline); 
    exit(1);
  }  

  Eval(HeadExpr,&Node);

  e.Type=Node.Type;
  switch (e.Type) {
    case SVALUE : e.N.Sym=Node.d.Sym; break;
    case NVALUE : e.N.Val=Node.d.Val; break;
  }

  if (!GetValueNum(HeadFunct,&e,&n)) {
    printf("%d: ",yyline); 
    printf("initial value out of range.\n");
    exit(1);
  }

  a=GetAtomNum(HeadFunct);
  if (pal_code!=errNONE) {
    printf("%d: %s\n",yyline,pal_errmsg);
    exit(1);
  }
  
  if (fGroundOut) {
    static char first=1;
    char *s=AtomNum2str(a,HeadFunct->Type);
    char *t=AtomVal2str(a,n,HeadFunct->Type);
    if (first) first=0; else fprintf(fGroundOut,",");
    fprintf(fGroundOut,"h(%s,%s)",s,t);
    free(s);
    free(t);
  }

  return GF->TreatInit(a,n);
}

int TreatAssign()
{
  struct tExpNode Node;
  struct Elem e;
  NUM n,a;

  if (! (HeadFunct->Type==ACTION
         && HeadFunct->Modifier==modNONE
	 && HeadFunct->Sit==0)) {
    printf("%d: `do' can only be performed on actions.\n",yyline); 
    exit(1);
  }  
  Eval(HeadExpr,&Node);

  e.Type=Node.Type;
  switch (e.Type) {
    case SVALUE : e.N.Sym=Node.d.Sym; break;
    case NVALUE : e.N.Val=Node.d.Val; break;
  }

  if (!GetValueNum(HeadFunct,&e,&n)) {
    showElem(&e);printf("\n");
    printf("%d: ",yyline); 
    printf("action value out of range.\n");
    exit(1);
  }
  
  a=GetAtomNum(HeadFunct);
  if (pal_code!=errNONE) {
    printf("%d: %s\n",yyline,pal_errmsg);
    exit(1);
  }

  return GF->TreatAssign(a,n);
}

int Ground(int (*whattodo)() )
{
  struct Elem **ranges;
  NUM *Cards,*Comb;
  unsigned int i;
  char ok=1;
  
  if (HeadFunct==NULL) 
    SemError("`false' is not a literal.",NULL);


  if (!NVars)
    return GenGround(whattodo);
  
  /* Transform VarList in a vector VarVec */
  VarVec=(struct tVarLstNode *)Queue2Array(VarList,sizeof(struct tVarLstNode),&i);
  qFree(&VarList);

  /* Store Ranges */
  ranges=(struct Elem **)malloc(NVars*sizeof(struct Elem *));  
  Cards=(NUM*)malloc(NVars*sizeof(NUM));
  Comb=(NUM*)calloc(NVars,sizeof(NUM));
  tup=(struct Elem*)malloc(NVars*sizeof(struct Elem));
  
  for (i=0;i<NVars;i++)
    if (VarVec[i].Type!=VAR) {
      printf("%d: ",yyline); 
      printf("References to other fluents or actions are not allowed.\n");
      exit(1);
    }
    else
      AddVarRange(VarVec,ranges,Cards,i);

  do {
    for (i=0;i<NVars;i++)
      memcpy(&tup[i],&ranges[i][Comb[i]],sizeof(struct Elem));
    if (!(ok=GenGround(whattodo))) break;
  } while (NextComb(Comb,Cards,NVars));

  free(ranges);
  free(Comb);
  free(Cards);
  free(tup);

  free(VarVec);
  VarVec=NULL;
  if (CondExpr!=NULL) btFree(&CondExpr);
  if (HeadExpr!=NULL) btFree(&HeadExpr);
  return ok;
}

void ConcTryState(SIT s)
{
  NUM *Comb,*Cards;
  BINVEC IsPers,IsPert;
  NUM i,n,v,left,right;

  #ifdef DEBUG
  printf("Trying state %d\n",s);
  #endif

  if (s>=ExprSit) {
    GF->ShowSolution();
    return;
  }

  Comb=(NUM*)calloc(TabAct.NSym,sizeof(NUM));
  Cards=(NUM*)calloc(TabAct.NSym,sizeof(NUM));
  IsPert=bvNew(TabAct.NSym);  
  IsPers=bvNew(TabAct.NSym);    
  
  left=(s==0)?0:QueryVec[s-1].NVars;
  right=(s==ExprSit-1)?NVars:QueryVec[s+1].NVars;
  
  /* Fix pertinence of actions already set in the query case ...*/
  for (i=left;i<right;i++)
    if (VarVec[i].Type==ACTION && VarVec[i].d.Funct->Sit==s) 
    {
      n=GetAtomNum(VarVec[i].d.Funct);
      if (pal_code!=errNONE) {
       if (OptVal[optWARNINGS]) printf("%d: Warning. %s\n",yyline,pal_errmsg);
       goto free_and_end;
      }
      
      switch(VarVec[i].d.Funct->Modifier) {
        case modPERT:
	  if (tup[i].N.Sym==TRUE_NSym) {
	    if (bvVal(IsPers,n)) goto free_and_end; 
            bvSet(IsPert,n,1); /* Fix pertinent  */
	  }
	  else {
	    if (bvVal(IsPert,n)) goto free_and_end; 
            bvSet(IsPers,n,1); /* Fix persistent */
	    Cards[n]=1;
	  }
	  break;
	  
	case modNONE:
	  if (bvVal(IsPers,n)) goto free_and_end;
	  bvSet(IsPert,n,1);
	  Cards[n]=1;
	  GetValueNum(VarVec[i].d.Funct,&tup[i],&Comb[n]);
      }
    }
  
  /*... and vary all the rest */
  for (i=0;i<TabAct.NSym;i++) {
    if(!Cards[i]) /* Not fixed yet */
      Cards[i]=((struct tAtom *)stEntry(TabAct,i))->pfh->RangeSize +
                (bvVal(IsPert,i)?0:1); /* and 1 if it can also persist */
  }

  do {
    /* Clean rule marks, actions & observations */
    GF->PushSit();
    #ifdef DEBUG
    printf("Trying action combination:\n");
    #endif
    /* Fix values for performed actions */
    for (i=0;i<TabAct.NSym;i++)
      if (!bvVal(IsPers,i)) /* if not mandatorily persistent */
        if (bvVal(IsPert,i)) /* if mandatorily pertinent */
	  GF->TreatAssign(i,Comb[i]);
	else
          if (Comb[i]>0) /* combination 0 becomes 'is persistent' */
	    GF->TreatAssign(i,Comb[i]-1);

    /* Fix observations */
    for (i=left;i<right;i++)
      if (VarVec[i].Type==FLUENT && VarVec[i].d.Funct->Sit==s) 
      {
	n=GetAtomNum(VarVec[i].d.Funct);
	if (pal_code!=errNONE) {
	 if (OptVal[optWARNINGS]) printf("%d: Warning. %s\n",yyline,pal_errmsg);
	 goto free_and_end;
	}
        if (VarVec[i].d.Funct->Modifier==modPERT)
	  GF->TreatObs(n,tup[i].N.Sym,modPERT);
	else {
	  GetValueNum(VarVec[i].d.Funct,&tup[i],&v);
	  GF->TreatObs(n,v,modNONE);
	}
      }

    /* Execute transition */
    if(GF->NewTrans())      
      ConcTryState(s+1);    /* try the rest of states     */
    GF->PopSit();  /* return to past 1 situation */
    
    if(OptVal[optSOLUTIONS] && NSol>=OptVal[optSOLUTIONS]) break;
  } while (NextComb(Comb,Cards,TabAct.NSym));
  
  
free_and_end :
  free(Comb);
  free(Cards);
  free(IsPert);
  free(IsPers);
}


void NoConcTryState(SIT s)
{
  NUM a=0;	/* action to fire. If none fixed, initially a=0 */
  NUM v=0;	/* value to fire */
  NUM Card;
  BINVEC IsPers;
  char IsPert=0;
  char FixedVal=0;
    
  NUM i,a2,v2,v3,f,NumVal;
  NUM left,right;

  #ifdef DEBUG
  printf("Trying state %d\n",s);
  #endif

  if (s>=ExprSit) {
    GF->ShowSolution();
    return;
  }

  IsPers=bvNew(TabAct.NSym);    
  
  left=(s==0)?0:QueryVec[s-1].NVars;
  right=(s==ExprSit-1)?NVars:QueryVec[s+1].NVars;

  /* Fix pertinence of actions already set in the query case ...*/
  for (i=left;i<right;i++)
    if (VarVec[i].Type==ACTION && VarVec[i].d.Funct->Sit==s) 
    {
      a2=GetAtomNum(VarVec[i].d.Funct);
      if (pal_code!=errNONE) {
       if (OptVal[optWARNINGS]) printf("%d: Warning. %s\n",yyline,pal_errmsg);
       goto NoConc_free_and_end;
      }
      switch (VarVec[i].d.Funct->Modifier) {
        case modPERT:
	  if (tup[i].N.Sym==TRUE_NSym) {      
	    /* inconsistence if a2 persistent or another action was pertinent*/
	    if (bvVal(IsPers,a2) || IsPert && a!=a2) 
	      goto NoConc_free_and_end;
	    IsPert=1;	/* Fix action a=a2 pertinent */
	    a=a2;
	  }
	  else {
	    if (IsPert && a==a2) goto NoConc_free_and_end;
            bvSet(IsPers,a2,1); /* Fix a2 persistent */
	  }
	  break;
	  
	case modNONE:
	  if (bvVal(IsPers,a2) || IsPert && a!=a2)
	    goto NoConc_free_and_end;
	  /*..... a ground query case never fixes 2 != values for 1 action */
	  GetValueNum(VarVec[i].d.Funct,&tup[i],&v);
	  IsPert=1;	/* Fix action a=a2 pertinent */
	  a=a2;
	  FixedVal=1;  /* and fix its value to v */
      }
    }

  a2=a;
  do {
    NumVal=((struct tAtom *)stEntry(TabAct,a2))->pfh->RangeSize;
    v2=v;
    do {
      /* Clean rule marks, actions & observations */
      GF->PushSit();
      #ifdef DEBUG
      printf("Trying action:\n");
      #endif
      /* Fix value for performed action */
      GF->TreatAssign(a2,v2);

      /* Fix observations */
      for (i=left;i<right;i++)
	if (VarVec[i].Type==FLUENT && VarVec[i].d.Funct->Sit==s) 
	{
	  f=GetAtomNum(VarVec[i].d.Funct);
	  if (pal_code!=errNONE) {
	   if (OptVal[optWARNINGS]) printf("%d: Warning. %s\n",yyline,pal_errmsg);
	   goto NoConc_free_and_end;
	  }
          if (VarVec[i].d.Funct->Modifier==modPERT)
	    GF->TreatObs(f,tup[i].N.Sym,modPERT);
	  else {
	    GetValueNum(VarVec[i].d.Funct,&tup[i],&v3);
	    GF->TreatObs(f,v3,modNONE);
	  }
	}

      /* Execute transition */
      if(GF->NewTrans())
	NoConcTryState(s+1);    /* try the rest of states     */
      GF->PopSit();  /* return to past 1 situation */

      if(OptVal[optSOLUTIONS] && NSol>=OptVal[optSOLUTIONS]) 
        goto NoConc_free_and_end;
    
      v2++;
    } while (!FixedVal && v2<NumVal);  
    a2++;
  } while (!IsPert && a2<TabAct.NSym);
  
NoConc_free_and_end :
  free(IsPers);
}

void OptimizeRange(BTREE e,NUM *Cards,struct Elem **ranges,BINVEC Singletons) 
{
  NUM VarNum;
  struct Elem elm;
  BTREE a,b;
  
  if (btRoot(e,struct tExpNode)->Type!=OPER) return;
  
  switch (btRoot(e,struct tExpNode)->d.Op) {
    case '=':
      if (btRoot(e->left,struct tExpNode)->Type==VAR && 
          ( btRoot(e->right,struct tExpNode)->Type==NVALUE ||
            btRoot(e->right,struct tExpNode)->Type==SVALUE )
	 )
      { a=e->left; b=e->right;}
      else
	if (btRoot(e->right,struct tExpNode)->Type==VAR && 
            ( btRoot(e->left,struct tExpNode)->Type==NVALUE ||
              btRoot(e->left,struct tExpNode)->Type==SVALUE )
	   )
        { a=e->right; b=e->left;}
	else
	  return;

      VarNum=btRoot(a,struct tExpNode)->d.Sym;
      elm.Type=btRoot(b,struct tExpNode)->Type;
      if (elm.Type==SVALUE) elm.N.Sym=btRoot(b,struct tExpNode)->d.Sym;
      else                  elm.N.Val=btRoot(b,struct tExpNode)->d.Val;      

      /* Check if it is already a singleton */
      if (bvVal(Singletons,VarNum)) {      
        /* we could check if it had value elm    */
	/* but we delay it until expr evaluation */
        return;
      }
      
      /* We could also check that the value belongs to codomain */
      
      /* Fix singleton range */
      bvSet(Singletons,VarNum,1);
      Cards[VarNum]=1;
      ranges[VarNum]=(struct Elem *)malloc(1*sizeof(struct Elem));
      memcpy(&ranges[VarNum][0],&elm,sizeof(struct Elem));
      break;
    
    case '^': case '&':
      OptimizeRange(e->left,Cards,ranges,Singletons);
      OptimizeRange(e->right,Cards,ranges,Singletons);
      break;

  }
}


void SolveGroundQuery()
{
  if(OptVal[optCONCURRENT])
    ConcTryState(1);
  else
    NoConcTryState(1);
}

void SolveQuery()
{
  unsigned foo;
  SIT s;
  NUM i;
  struct Elem **ranges=NULL;
  NUM *Cards=NULL,*Comb=NULL;
  char unknown=0;
  BINVEC Singletons;

  NSol=0;
  verbose=0; /* do not explain inconsistence */
  IniSit=Now;
  HasVars=0;
  
  /* Transform Lists in vectors */
  VarVec=(struct tVarLstNode *)Queue2Array(VarList,sizeof(struct tVarLstNode),&foo);
  qFree(&VarList);

  QueryVec=(tQueryNode *)Queue2Array(QueryList,sizeof(tQueryNode),&foo);
  qFree(&QueryList);

  /* Store Ranges */
  if (NVars) {
    Singletons=bvNew(NVars);
    ranges=(struct Elem **)malloc(NVars*sizeof(struct Elem *));  
    Cards=(NUM*)malloc(NVars*sizeof(NUM));
    Comb=(NUM*)calloc(NVars,sizeof(NUM));
    tup=(struct Elem*)malloc(NVars*sizeof(struct Elem));
    
    for (i=0;i<NVars;i++)
      if (VarVec[i].Type==VAR) {
        HasVars=1;
	AddVarRange(VarVec,ranges,Cards,i);
      }
      else 
	if(VarVec[i].d.Funct->Sit>0)
	  AddVarRange(VarVec,ranges,Cards,i);
	else {
	  /* For each initial action or fluent, use a singleton range */
	  Cards[i]=1;
	  ranges[i]=(struct Elem *)malloc(1*sizeof(struct Elem));
	  bvSet(Singletons,i,1);
	}

    /* Optimize conjunctions like VAR=constant so that they use a */
    /* singleton range                                            */
    for (s=0;s<ExprSit;s++)
      OptimizeRange(QueryVec[s].Expr,Cards,ranges,Singletons);
    /* ---------- */

  }
    
  do {
    unknown=0;
    for (i=0;i<NVars;i++) 
      memcpy(&tup[i],&ranges[i][Comb[i]],sizeof(struct Elem));
    /* Use current value for fluents and actions */
    for (i=0;i<NVars && !unknown ;i++)
      if (VarVec[i].Type!=VAR && VarVec[i].d.Funct->Sit<=0)
	unknown=!GF->GetCurValue(VarVec+i,&tup[i]);
 
    s=0;
    if (!unknown) {
      for (s=0;s<ExprSit &&
               (QueryVec[s].Expr==NULL||ExprIsTrue(QueryVec[s].Expr));s++);
      if (s==ExprSit) /* ground query case found */
      {
	int j;
	#ifdef DEBUG  
	printf("query case < ");
	for (j=0;j<NVars;j++)
	  if(VarVec[j].Type!=VAR) {
	    showFunct(VarVec[j].d.Funct);
	    printf("=");
	    showElem(&tup[j]);
	    printf(" ");
	  }
	printf(">\n");
	#endif
	if (fGroundOut) {WriteGroundQuery(); break;}
	else
	  GF->SolveGroundQuery();
	  
	if(OptVal[optSOLUTIONS] && NSol>=OptVal[optSOLUTIONS]) break;
	
	s--;
      }
      else
	for (i=QueryVec[s].NVars;i<NVars;i++) Comb[i]=0;
    }
  } while(s>=0 && NextComb(Comb,Cards,QueryVec[s].NVars));


  if (NVars) {
    /* free singleton ranges */
    for(i=0;i<NVars;i++)
      if (bvVal(Singletons,i)) free(ranges[i]);
    free(ranges);
    free(Comb);
    free(Cards);
    free(tup);
    free(VarVec);
  }
  
  free(QueryVec);
  if(NSol)
    if (!HasVars&&ExprSit==1) printf("yes\n");
    else
      printf("\n%d solution%s\n",NSol,(NSol>1)?"s":"");
  else printf("no\n");

  ExprSit=0;
  verbose=1;
}

void EvalAndPrintExpression(BTREE Expr)
/** Evaluates and prints an expression
  * @addition date: 24/10/2001
  */
{
  unsigned foo;
  NUM i;
  struct tExpNode Node;
  struct Elem e;

  #ifdef DEBUG
  printf("Eval and print expression: "); 
  showTree(Expr);
  printf("\n");
  #endif

  VarVec=NULL;
  tup=NULL;
  
  /* Transform Lists in vectors */
  VarVec=(struct tVarLstNode *)Queue2Array(VarList,sizeof(struct tVarLstNode),&foo);
  qFree(&VarList);

  /* If there are fluents, actions or variables */
  if (NVars) {
    /* By now, no variables allowed */
    for (i=0;i<NVars && VarVec[i].Type!=VAR;i++) ;  
    if (i<NVars) {
      printf("No variables allowed for `print'.\n");    
      goto FREE_AND_EXIT_0;
    }
    
    /* Allocate the tuple for all the variables */   
    tup=(struct Elem*)malloc(NVars*sizeof(struct Elem));

    /* Store current values in the tuple for fluents and actions */
    for (i=0;i<NVars;i++)
      if (!GF->GetCurValue(VarVec+i,&tup[i])) /* some unknown value */
      {
	printf("[unknown: "); 
	showFunct(VarVec[i].d.Funct);
	printf("]\n"); 
	goto FREE_AND_EXIT_0;
      }
  } /* end if(NVars) */

  Eval(Expr,&Node);

  e.Type=Node.Type;
  switch (e.Type) {
    case SVALUE : e.N.Sym=Node.d.Sym; break;
    case NVALUE : e.N.Val=Node.d.Val; break;
  }  

  showElem(&e);
  
FREE_AND_EXIT_0:
  if (VarVec!=NULL) free(VarVec);
  if (tup!=NULL) free(tup);
}


void SplitOption(char *arg, char **option, char *type, void **ptrVal)
{
  int length1, length2;
  char *sv=NULL;
  int v;
  char *endptr;
  
  sv=strchr(arg,(int)'=');
  if (sv==NULL) {
      printf("`%s', invalid option. For detailed help, type: pal -h\n",arg);
      exit(1);
  }
  length2=strlen(++sv);
  length1 = strlen(arg) - length2 - 1;
  *option=(char *)malloc(length1+1);
  strncpy(*option,arg,length1);
  
  /* check whether the value is a number or not */
  
  v=(int)strtol(sv,&endptr,10);
  if (endptr[0]==0) {
    if (errno!=0) {
      printf("Value %s out of range for option %s\n",sv,option);
      exit(1);
    }
    *type=NVALUE;
    *ptrVal=(void *)malloc(sizeof(int));
    memcpy(*ptrVal,&v,sizeof(int));
  }
  else {
    *type=SVALUE;
    *ptrVal=(char *)malloc(length2+1);
    memcpy(*ptrVal,sv,length2+1);
  }
}


void SetOpt(char *s,char type,void *ptrVal)
{
  int opt;
  int val;
  for(opt=0;opt<NOPT && strcmp(txtOpt[opt],s)!=0;opt++);
  if (opt>=NOPT) {
    printf("%d: `%s', unrecognized option.\n",yyline,s);
    return;
  }
  
  if (type==SVALUE) {
    for(val=0;val<OptNumVal[opt] && 
              strcmp(txtOptVal[opt][val],(char *)ptrVal)!=0;val++);
    if (val>=OptNumVal[opt]) {
      printf("%d: `%s', unrecognized value for option %s.\n",
             yyline,(char*)ptrVal,s);
      return;
    }  
  }
  else
    val=*(int*)ptrVal;
    
  switch(opt) {
    case optSOLUTIONS:
    case optINFERENCE:            
      if (opt==optINFERENCE)
        GF=GetGF(val);
      break;
    case optCONCURRENT:
      if (val!=0 && val!=1) {
	printf("%d: invalid value for option `%s'.\n",yyline,s);
	return;
      }     
      if (fGroundOut) 
        fprintf(fGroundOut,"options\n %s concurrent;\n",(val)?"":"not");
      break;
    case optUNKNOWN:
    case optWARNINGS:
    case optMUTE:
      if (val!=0 && val!=1) {
	printf("%d: invalid value for option `%s'.\n",yyline,s);
	return;
      }     
      break;
  }
  OptVal[opt]=val;
  #ifdef DEBUG
  if (type==SVALUE)
    printf("Set option %s=%s\n",s,(char*)ptrVal);
  else
    printf("Set option %s=%d\n",s,val);
  #endif
}


struct tVarLstNode *GetVarLstElm(NUM n)
{
  QUEUE q;
  NUM i;
  
  q=VarList;
  for (i=0;i<n;i++) q=q->next;
  return qFirst(q,struct tVarLstNode);
}


int TupleCopy(QUEUE q,void *d) {
  BTREE e;
  QUEUE *Tuple=(QUEUE *)d;
  e=ExprCopy(*qFirst(q,BTREE));
  qInsertLast(Tuple,&e,sizeof(BTREE));
  return 0;
}

struct tFunct *FunctCopy(struct tFunct *pf) {
  struct tFunct *pf2;
  
  pf2=(struct tFunct *)malloc(sizeof(struct tFunct));
  memcpy(pf2,pf,sizeof(struct tFunct));
  if (ShiftSit) pf2->Sit++;
  pf2->Tuple=NULL;
  if (pf->Tuple!=NULL)
    qBrowse(pf->Tuple,TupleCopy,&pf2->Tuple);
  return pf2;
}

BTREE ExprCopy(BTREE e)
{
  struct tExpNode n;
  struct tVarLstNode vn,*pvn;
  BTREE r,l;
  
  if (e==NULL) return NULL;
  l=ExprCopy(e->left);
  r=ExprCopy(e->right);
  memcpy(&n,btRoot(e,struct tExpNode),sizeof(struct tExpNode));
  if (n.Type==VAR) {
    pvn=GetVarLstElm(n.d.Sym);
    if (pvn->Type!=VAR) {
      vn.Type=pvn->Type;
      vn.d.Funct=FunctCopy(pvn->d.Funct);
      n.d.Sym=InsertNewVar(&VarList,vn.Type,0,vn.d.Funct);
    }
  }
  
  return Tree(&n,l,r);
}


struct tGenericFunctions *GetGF(int val)
{
  switch(val) {
    case 0: 
    case 3: 
      return &WFGF;
    case 1: 
      #ifdef MEDTOOL
      return &MCGF; 
      #else
      printf("Executable version not compiled with Medtool-Connection libraries\n");
      exit(1);
      #endif

      break;
    case 2: 
      #ifdef SMODELS
      return &SMGF; 
      #else
      printf("Executable version not compiled for smodels.\n");
      exit(1);
      #endif

      break;
    default:
      printf("%d: invalid value for option `inference'.\n",yyline);
  }
}

/*** FUNCTIONS FOR CONNECTION TO PROLOG PLANNER **************/

void WriteGroundAtoms(struct tFunctHeader *pf,char Type)
{
  NUM i,j;
  static int LastType=VAR; /* anything different from FLUENT or ACTION */
  char *s=NULL;
 
  if (Type!=LastType) {
    if (LastType!=VAR) fprintf(fGroundOut,"\n");
    fprintf(fGroundOut,(Type==ACTION)?"\nactions\n":"\nfluents\n");
    LastType=Type;
  }
  
  for (i=pf->BaseNSym;i<pf->BaseNSym+pf->NTuples;i++) {

    /* Print the atom name */    
    s=AtomNum2str(i,Type);
    fprintf(fGroundOut,"%s",s);
    free(s);
    
    /* Print its range */
    fprintf(fGroundOut,":");
    for (j=0;j<=pf->RangeSize-1;j++) {
      s=Elem2str(&pf->Range[j]);
      fprintf(fGroundOut,"%s%s",s,(j!=pf->RangeSize-1)?",":"; ");
      free(s);
    }
  }
}

void WriteInstancedSymbol(unsigned i,char ShowPrev) 
{
  NUM n,a;
  char *s,*v;
  char c;

  a=GetAtomNum(VarVec[i].d.Funct);
  s=AtomNum2str(a,VarVec[i].d.Funct->Type);

  if (VarVec[i].d.Funct->Sit!=0 && ShowPrev) 
    fprintf(fGroundOut,"prev(",s);

  if (VarVec[i].d.Funct->Modifier==modPERT) {
    c='p';
    if (tup[i].N.Sym==TRUE_NSym)
      v=strCopy("true");
    else
      v=strCopy("false");
  }
  else {
    c='h';
    GetValueNum(VarVec[i].d.Funct,&tup[i],&n);
    v=AtomVal2str(a,n,VarVec[i].d.Funct->Type);
  }

  fprintf(fGroundOut,"%c(%s,%s)",c,s,v);
  if (VarVec[i].d.Funct->Sit!=0 && ShowPrev) 
    fprintf(fGroundOut,")");
  free(s);
  free(v);
}

void WriteGroundRule(unsigned Num) {
  unsigned i;
  struct Elem e;
  struct tExpNode Node;
  NUM n,a;
  static char first=1;
  char *s,*v;
  
  if (first) 
    {fprintf(fGroundOut,"\n\nrules\n"); first=0;}
  else fprintf(fGroundOut,";\n");

  if (HeadFunct==NULL) 
    fprintf(fGroundOut,"false");
  else {
    Eval(HeadExpr,&Node);
    e.Type=Node.Type;
    switch (e.Type) {
      case SVALUE : e.N.Sym=Node.d.Sym; break;
      case NVALUE : e.N.Val=Node.d.Val; break;
    }
    if (GetValueNum(HeadFunct,&e,&n)) {
      a=GetAtomNum(HeadFunct);
      s=AtomNum2str(a,HeadFunct->Type);
      v=AtomVal2str(a,n,HeadFunct->Type);
      fprintf(fGroundOut,"h(%s,%s)",s,v);
      free(s);
      free(v);
    }
    else
      fprintf(fGroundOut,"false");
  }
  fprintf(fGroundOut," if ");

  for (i=0;i<Num;i++)
    if (VarVec[i].Type!=VAR) {
      WriteInstancedSymbol(i,1);
      if (i!=Num-1) fprintf(fGroundOut," and ");
    }
}

void WriteGroundQuery() {
  unsigned i;
  static char first=1,first0=1;
  NUM left,right;
  SIT s;
  
  fprintf(fGroundOut,"\nquery\n");
  for (s=0;s<ExprSit;s++) {
    if (first0) first0=0;
    else fprintf(fGroundOut,"; ");
    left=(s==0)?0:QueryVec[s-1].NVars;
    right=(s==ExprSit-1)?NVars:QueryVec[s+1].NVars;
    first=1;
    for (i=left;i<right;i++) {
      if (VarVec[i].Type!=VAR && VarVec[i].d.Funct->Sit==s) {
	if (first) first=0;
	else fprintf(fGroundOut," and ");
	WriteInstancedSymbol(i,0);
      }
    }
  }
  fprintf(fGroundOut," ?\n");
}

/*************************************************************/
char *Elem2str(struct Elem *e)
{
  char *s,t[80];

  if (e->Type==NVALUE) {
    sprintf(t,"%d",e->N.Val);
    s=strCopy(t);
  }
  else
    s=strCopy((char *)stEntry(SymTables[e->Type],e->N.Sym));
  return s;
}

void showElem(struct Elem *e)
{
  char *s=Elem2str(e);
  printf("%s",s);
  free(s);
}

char *Value2str(struct tExpNode *e)
{
  char *s,t[80];

  if (e->Type==NVALUE) {
    sprintf(t,"%d",e->d.Val);
    s=strCopy(t);
  }
  else
    s=strCopy((char*)stEntry(SymTables[e->Type],e->d.Sym));

  return s;
}

void showVALUE(struct tExpNode *e)
{
  if (e->Type==NVALUE)
    printf("%d",e->d.Val);
  else
    printf("%s",stEntry(SymTables[e->Type],e->d.Sym));
}


char *Atom2str(struct tAtom *a,char Type)
{
  NUM j;
  struct tFunctHeader *pf;
  char *types;
  ELMVAL *vals;
  char *s;
  char t[80];
  
  s=strCopy((char *)stEntry(SymTables[Type],a->NSym));

  pf=(struct tFunctHeader *)stEntry(SymData[Type],a->NSym);
  
  vals=(ELMVAL *)a->pcktuple;
  types=a->pcktuple+sizeof(ELMVAL)*pf->Arity;
  if (pf->Arity>0) 
    if (fGroundOut)
      s=strAppend(s,"_");
    else
      s=strAppend(s,"(");
  for (j=0;j<pf->Arity;j++) {
    if (types[j]!=NVALUE)
      s=strAppend(s,stEntry(SymTables[types[j]],vals[j].Sym));
    else {
      sprintf(t,"%d",vals[j].Val);
      s=strAppend(s,t);
    }
    if (fGroundOut) {
      t[0]=0;
      if (j<pf->Arity-1) strcpy(t,"_");
    }
    else
      {t[0]=(j==pf->Arity-1)?')':',';t[1]=0;}
    s=strAppend(s,t);
  }  
  return s;
}


void showAtom2(struct tAtom *a,char Type)
{
  char *s=Atom2str(a,Type);
  printf("%s",s);
  free(s);
}

char *AtomNum2str(NUM i,char Type)
{
  struct tAtom *a;
  struct SymTable *AtomsTable;
  
  switch (Type) {
    case ACTION: AtomsTable=&TabAct; break;
    case FLUENT: AtomsTable=&TabFlu; break;
  }
  a=(struct tAtom *)stEntry(*AtomsTable,i);  
  return Atom2str(a,Type);
}

void showAtom(NUM i,char Type)
{
  char *s=AtomNum2str(i,Type);
  printf("%s",s);
  free(s);  
}


char *AtomVal2str(NUM i,NUM v,char Type)
{
  struct tFunctHeader *pf;
  struct tAtom *a;
  struct SymTable *AtomsTable;
  char *s;
  
  switch (Type) {
    case ACTION: AtomsTable=&TabAct; break;
    case FLUENT: AtomsTable=&TabFlu; break;
  }
  a=(struct tAtom *)stEntry(*AtomsTable,i);  
  
  pf=(struct tFunctHeader *)stEntry(SymData[Type],a->NSym);  
  
  return Elem2str(&pf->Range[v]);
}

void showAtomVal(NUM i,NUM v,char Type)
{
  char *s=AtomVal2str(i,v,Type);
  printf("%s",s);
  free(s);  
}

void showAtoms(struct tFunctHeader *pf,char Type)
{
  NUM i;
  for (i=pf->BaseNSym;i<pf->BaseNSym+pf->NTuples;i++)
    showAtom(i,Type);
}


void printbanner()
{
   printf("*** PAL "); printf(VER);printf(" (Pertinence Action Language)\n");
   printf("*** (c) 1999-2000 Pedro Cabalar, %s, AI Lab, Univ. of Corunna\n",
          __DATE__);
   printf("*** http://www.dc.fi.udc.es/ai/~cabalar/pal/\n");
}

void printhelp()
{
 printf("[***]printhelp\n");
 exit(1);
}


int showTree2(BTREE t)
{
  if (t==NULL) return 1;
    
  if (Root(t).Type==OPER) printf("(");
  showTree2(t->left);
  switch(Root(t).Type) {
    case NVALUE: printf("%d",Root(t).d.Val); break;
    case SVALUE: printf("%s",stEntry(SymTables[SVALUE],Root(t).d.Sym)); break;
    case VAR: 	 printf("[%d]",Root(t).d.Sym); break;
    case OPER:	 printf("%c",Root(t).d.Op); break;
  }
  showTree2(t->right);
  if (Root(t).Type==OPER) printf(")");
  return 1;
}

int showTree(BTREE t)
{
  showTree2(t);
}

static int browsetuple(QUEUE q,void *d)
{
  printf("%c",(*(char *)d)?'(':',');
  *(char *)d=0;
  showTree(*qFirst(q,BTREE));
  return 0;
}

void showFunct(struct tFunct *pf)
{
  char first=1;
  if (pf->Modifier==modPERT) printf("pert(");

  printf("%s",stEntry(SymTables[pf->Type],pf->NSym));
  if (qIsNotEmpty(pf->Tuple)) {
    first=1;
    qBrowse(pf->Tuple,browsetuple,(void *)&first);
    printf(")");
  }
  if (pf->Modifier==modPERT) printf(")");
  if (pf->Sit!=0) printf("@%d",pf->Sit);
}

int showVarLstElm(QUEUE q,void *d)
{
  struct tVarLstNode *pn;
  pn=qFirst(q,struct tVarLstNode);
  if (pn->Type==VAR)
    printf("%s",stEntry(SymTables[VAR],pn->d.Sym));
  else
    showFunct(pn->d.Funct);
  printf(" ");
  return 0;
}

void showRule(unsigned Num)
{
  unsigned i;
  struct Elem e;
  struct tExpNode Node;
  NUM n,a;

  if (HeadFunct==NULL) 
    printf("false");
  else {
    Eval(HeadExpr,&Node);
    e.Type=Node.Type;
    switch (e.Type) {
      case SVALUE : e.N.Sym=Node.d.Sym; break;
      case NVALUE : e.N.Val=Node.d.Val; break;
    }
    a=GetAtomNum(HeadFunct);
    if (pal_code!=errNONE && OptVal[optWARNINGS]) {
      printf("\n%d: Warning. %s\n",yyline,pal_errmsg);
      return;
    }
    if (GetValueNum(HeadFunct,&e,&n)) {
      showAtom(a,HeadFunct->Type);
      printf(":=");
      showAtomVal(a,n,HeadFunct->Type);
    }
    else {
	if (OptVal[optWARNINGS]) {
	  printf("Warning: head `");
	  showAtom(a,HeadFunct->Type);
	  printf(":=");
	  showElem(&e);
	  printf("' out of range in rule %d. Converted into `false'.\n",
	  RuleCount,yyline); 
	}
	printf("false");
      }
  }

  printf(" if ");
  for (i=0;i<Num;i++)
    if (VarVec[i].Type!=VAR) {
      if (VarVec[i].d.Funct->Modifier==modPERT) printf("pert_");
      else if (VarVec[i].d.Funct->Sit!=0) printf("prev_");

      a=GetAtomNum(VarVec[i].d.Funct);
      if (pal_code!=errNONE && OptVal[optWARNINGS]) {
        printf("\n%d: Warning. %s\n",yyline,pal_errmsg);
	return;
      }
      showAtom(a,VarVec[i].d.Funct->Type);
      if (VarVec[i].d.Funct->Modifier==modPERT)
        n=tup[i].N.Sym;
      else
        GetValueNum(VarVec[i].d.Funct,&tup[i],&n);
      printf("=");
      showAtomVal(a,n,VarVec[i].d.Funct->Type);
      printf(" ");
    }

  printf("\n");
}

unsigned GetRulNum(NUM r) {
  NUM i,j;
  
  r++;
  for (j=0,i=0;i<RuleCount && j<r;
       j+=((tRulInfo*)stEntry(tabRulInfo,i))->nRul, i++);

  if (i>0) --i;
  return i;
}
