/* Medtool Connection Classic Header File */

/* Copyright  1992-1998 Ramon P. Otero. */
/* All Rights Reserved. */
/* Artificial Intelligence Lab. */
/* University of Corunna, Galicia, Spain. */
/* e-mail: medtool@dc.fi.udc.es */
/* url: www.dc.fi.udc.es/ai/medtool.html */
/* Feb. 1998 */


/* Unix */
#ifdef unix
#define _far
#define FAR
#define PASCAL
#endif

 /* all functions return 0 when error */
 /* and an error message in error string */
typedef char _far *MCError;
typedef char _far *sparam;
typedef unsigned int _far *uparam;
typedef unsigned char _far *cparam;
typedef unsigned long _far *lparam;
typedef double _far *dparam;
typedef struct tm _far *tparam;

 /* error string definition */
#ifdef smallapp
char mederror[512]="";
#else
extern char mederror[];
#endif

 /* shown in temporal order of use */
int FAR PASCAL mcerror (MCError);
 /* MCError: string for returned errors */
 /* plese call it as:  mcerror ((MCError) mederror); */
 /* return 1 OK, else error */
 /* return when 1: mederror contains MC version id */
 /* MC version id: "MCyy-nnns", yy=year, nnn=number, s=system */
 /* system: "u" Unix, "w" Windows */

 /* medtool general options */
#define NETON 0x0000
#define NETOFF 0x0001
#define LANGUAGEUSA 0x1000
#define LANGUAGEESP 0x2000

int FAR PASCAL medsetoptions (unsigned int);
 /* must be called just after mcerror() and before any other function... */
 /* ... to take effect in some options: NETxx */
 /* only one single option at a time */
 /* sparams: option value */
int FAR PASCAL medtool (sparam, sparam);
 /* sparams: user name and password */
int FAR PASCAL medtoolbyes (sparam, sparam, sparam);
 /* sparams: esfile, user name and password */
int FAR PASCAL medtoolnew (sparam, sparam, sparam, sparam, sparam);
 /* when it is the first time medtool is called */
 /* sparams: esfile name, usrd, passd, usrn, passn user names and password for designer and regular user, all required*/
int FAR PASCAL medtoolexit (void);
 /* exit from medtool, only necessary for reload and es change */

int FAR PASCAL user (sparam, sparam);
 /* sparams: user name and password */
int FAR PASCAL userid (uparam);
 /* uparam: current user id number (returned) */
int FAR PASCAL usertype (cparam);
 /* cparam: current user type (returned) */
int FAR PASCAL username (sparam);
 /* uparam: current user name (returned) */


 /* regular user interface */
 /* ---------------------- */
 /* subjects management */
int FAR PASCAL subjects (uparam);
 /* uparam: number of subjects (returned) */
int FAR PASCAL firstsubject (void);
 /* positioning in the first subject */
 /* for repetitive call functions */
int FAR PASCAL nextsubject (void);
 /* positioning in the next subject */
 /* for repetitive call functions */
int FAR PASCAL subjectid (uparam);
 /* uparam: subject id number (returned) */
int FAR PASCAL subjectname (sparam);
 /* uparam: subject name (returned) */

int FAR PASCAL subjectnamefromid (unsigned int, sparam);
 /* uparam: subject id number, subject name (returned) */
int FAR PASCAL subjectidfromn (unsigned int, uparam);
 /* uparam: subject order number 1..n, subject id number (returned) */

int FAR PASCAL opensubject (unsigned int);
 /* param: subject id number */
int FAR PASCAL opensubjectname (sparam);
 /* sparam: subject name */
int FAR PASCAL opensubjectn (unsigned int);
 /* param: subject order number 1..n */
int FAR PASCAL creatsubject (uparam);
 /* uparam: subject id number (returned) */
int FAR PASCAL creatsubjectname (sparam, uparam);
 /* uparam: sparam subject name, subject id number (returned) */
int FAR PASCAL closesubject (unsigned int);
int FAR PASCAL deletesubject (unsigned int);

 /* subject state flags */
 /* read-only internal flags */
#define SUJOPEN '\x01'
#define SUJNEWDATA '\x02'
 /* read-write flags for external use */
#define SUJFLAG1 '\x10'
#define SUJFLAG2 '\x20'
#define SUJFLAGMAX '\x33'
int FAR PASCAL getsubjectflag (unsigned int, char, cparam);
 /* unsigned int: subject id number */
 /* char: flags id numbers (ored if wanted) */
 /* cparam: subject state flag value (returned) */
int FAR PASCAL setsubjectflag (unsigned int, char, char);
 /* unsigned int: subject id number */
 /* char: flag id number (only one flag) */
 /* char: subject state flag value (0 or 1) */

 /* subject last modif time */
int FAR PASCAL getsubjectendtime (unsigned int, lparam);
 /* unsigned int: subject id number */
 /* lparam: subject last time (returned) */

 /* data input */
int FAR PASCAL newdatabegin (unsigned int, lparam);
 /* unsigned int: subject id number */
 /* lparam: all data in the same time reference, by default */
 /* if NULL then get current time */
int FAR PASCAL newdataid (unsigned int, unsigned int, double, sparam);
 /* params: subject id, dataid, new value when number, new value when not number */
int FAR PASCAL newdataname (unsigned int, sparam, double, sparam);
 /* params: subject id, dataname, new value when number, new value when not number */
int FAR PASCAL newdataidtime (unsigned int, unsigned int, lparam, double, sparam);
 /* params: subject id, dataid, datatime, new value when number, new value when not number */
int FAR PASCAL newdatanametime (unsigned int, sparam, lparam, double, sparam);
 /* params: subject id, dataname, datatime, new value when number, new value when not number */

 /* infer options bitwise-ored */
#define SAVEDATA 1
#define USENET 2
#define ASSEMB 4
#define CLAUSE 8
#define CONCURRENT 32
#define IOCONCURRENT 64
#define PARALLEL 128
int FAR PASCAL infer (unsigned int, unsigned int);
 /* new data end and infer new data */
 /* params: subject id number, options bitwise-or */
 /* SAVEDATA: save data to file when infer end */
 /* USENET: use inference net to speed up infer */
 /* CLAUSE: use if-clause pertinent control to speed up infer */
 /* CONCURRENT: concurrent infer, where available */
 /* IOCONCURRENT: concurrent I/O for save data, where available */
 /* PARALLEL: parallel infer, use of multiprocessors where available */

#define NEW 0
#define IGNORANCE 1
#define NOPERTINENT 2
#define DEDUCED 3
#define INDUCED 4
#define INCONSISTENT 5
#define REDUNDANT 6
#define INCOHERENT 7
int FAR PASCAL inferinfo (unsigned int, unsigned int, uparam);
 /* params: subject id number, inferinfo code, value returned */

 /* data output */
 /* getting all data from all open subjects */
int FAR PASCAL getdataid (unsigned int, unsigned int, dparam, sparam);
 /* params: subject id, dataid, returned value when number, returned value when not number */
int FAR PASCAL getdataname (unsigned int, sparam, dparam, sparam);
 /* params: subject id, dataname, returned value when number, returned value when not number */

 /* getting data just inferred from all open subjects */
 /* buffer valid until next call to newdata() or infer() */
 /* set of functions to get all the data */
int FAR PASCAL firstnewdata (unsigned int);
 /* positioning in the first new data, param subject */
 /* for repetitive call functions */
int FAR PASCAL nextnewdata (unsigned int);
 /* positioning in the next new data, param subject */
 /* for repetitive call functions */
int FAR PASCAL getnewdataid (unsigned int, uparam, dparam, sparam);
 /* params: subject id, returned dataid, returned value when number, returned value when not number */
int FAR PASCAL getnewdataname (unsigned int, sparam, dparam, sparam);
 /* params: subject id, returned dataname, returned value when number, returned value when not number */

 /* getting data just inferred from all open subjects */
 /* buffer valid until next call to newdata() or infer() */
 /* set of functions to get selected data */
int FAR PASCAL getnewdatabyid (unsigned int, unsigned int, dparam, sparam);
 /* params: subject id, dataid, returned value when number, returned value when not number */



 /* designer interface */
 /* ------------------ */
 /* the current user must be of type designer */

 /* sign types */
#define NUMBER 'N'
#define NOTNUMBER 'P'

 /* predefined slots of a sign */
#define MAXSLOT 8
#define MINSLOT 0
#define PHRASE 0
#define SIGN 1
#define VALUES 2
#define VKECOM 3
#define KECOM 4
#define OTHER 5
#define VKE 6
#define KE 7
#define TYPE 8

 /* predefined groups of signs */
#define THEINDEX 200
#define THEVALUES 210
#define THEOPERATORS 211
#define THEGENERAL 212
#define THEREGULAR 300

 /* sign definition */
 /* --------------- */
 /* new signs definition */
int FAR PASCAL newsignbyids (unsigned int, unsigned int, char, sparam signname, uparam);
 /* params: groupid, subgroupid, N or P, signname, signid number (returned) */
int FAR PASCAL newsignbynames (sparam, sparam, char, sparam, uparam);
 /* params: groupname, subgroupname, N or P, signname, signid number (returned) */
int FAR PASCAL newgroup (sparam, uparam);
 /* params: groupname, groupid number (returned) */
int FAR PASCAL newsubgroup (sparam, sparam, uparam);
 /* params: groupname (to which belongs), subgroupname, subgroupid number (returned) */

 /* modif existing sign */
int FAR PASCAL modifsignbyid (unsigned int, char, sparam);
 /* params: signid, slotid, new content for slot */
int FAR PASCAL modifsignbyname (sparam, char, sparam);
 /* params: gmname, slotid, new content for slot */

 /* delete sign */
int FAR PASCAL deletesignbyid (unsigned int);
 /* params: signid number */
int FAR PASCAL deletesignbyname (sparam);
 /* params: signname */

 /* save expert system file */
int FAR PASCAL savees (void);
 /* no params */
int FAR PASCAL revisees (void);
 /* no params */
int FAR PASCAL saveestxt (sparam);
 /* sparam: file name */
int FAR PASCAL saveessgm (sparam);
 /* sparam: file name */
int FAR PASCAL setesinfo (sparam, sparam, sparam, sparam, sparam);
 /* sparams: author, org, date, version and espassword required to change info */
 /* espassword is the password of designer user who has create this es */
int FAR PASCAL getesinfo (sparam, sparam, sparam, sparam, sparam);
 /* sparams: esfile name, author, org, date, version */
#define MAXSIGN 0
#define MAXMG 1
#define MAXVAL 2
#define MAXOP 3
#define MAXI 4
#define MAXMGI 5
#define MCMAX 6
#define DEFMAX 7
#define CMAX 8
 /* and the extended slots */
#define KCHAR 9
#define KTCHAR 10
#define LAYERS 11
#define NOTUSED 12
#define INITIAL 13
#define FINAL 14
#define POSCYCLES 15
int FAR PASCAL extesinfo (unsigned int, uparam);
 /* params: esinfo code, value returned */

 /* sign lookup */
 /* ----------- */
 /* read-only pseudo-slots of a sign */
#define GROUP 9
#define SUBGROUP 10
 /* and the extended maxslot */
#define EXTMAXSLOT 10

 /* sign contents */
int FAR PASCAL getsignbyid (unsigned int, char, sparam);
 /* params: signid, slotid, content for slot (returned) */
int FAR PASCAL getsignbyname (sparam, char, sparam);
 /* params: gmname, slotid, content for slot (returned) */
 /* extended sign contents */
int FAR PASCAL getextsignbyid (unsigned int, char, char, sparam);
 /* params: signid, slotid, extslotid, content for slot (returned) */
int FAR PASCAL getextsignbyname (sparam, char, char, sparam);
 /* params: gmname, slotid, extslotid, content for slot (returned) */

 /* defined info of a sign */
#define SIGNID 0
#define GROUPID 1
#define SUBGROUPID 2
#define VALUESNUM 3
#define VALUESMAX 4
#define VALUESFLAG 5
#define KENUM 6
#define OTHERNUM 7

#define MAXINFO 7
#define MININFO 0
 /* sign info */
int FAR PASCAL signinfobyid (unsigned int, char, uparam);
 /* params: signid, infoid, value (returned) */
int FAR PASCAL signinfobyname (sparam, char, uparam);
 /* params: signname, infoid, value (returned) */

 /* sign s */
 /* ---------- */
 /* lockids */
#define E '\x01'	/* E 1 evaluated */ 
#define P '\x02'	/* P 2 pending (cycles) */
#define N '\x04'	/* N 4 non-pertinent */
#define I '\x08'	/* I 8 ignorance */
#define Z '\x10'	/* Z 16 (0x10) KEs off */
#define D '\x20'	/* D 32 external datum (user/autoacquired) */
		/* available '\x40' '\x80' (8 bits) */
 /* locktypes */
#define LOCKEDIT '\x01'
#define LOCKEVAL '\x02'
int FAR PASCAL locksignbyid (unsigned int, char, char, char);
 /* params: signid, locktype, lockid, value (0/1) */
int FAR PASCAL locksignbyname (sparam, char, char, char);
 /* params: signname, locktype, lockid, value (0/1) */
int FAR PASCAL testsignbyid (unsigned int, char, char, cparam);
 /* params: signid, locktype, lockid, value (0/1) (returned) */
int FAR PASCAL testsignbyname (sparam, char, char, cparam);
 /* params: signname, locktype, lockid, value (0/1) (returned) */
int FAR PASCAL lockallsigns (char, char, char);
 /* params: locktype, lockid, value (0/1) */
int FAR PASCAL lockclearall (char);
 /* params: locktype, clear (0) all locks for all signs */

 /* signs structure */
 /* --------------- */
int FAR PASCAL firstsign (sparam, sparam);
 /* params: groupname, subgroupname */
 /* positioning in the first sign of group/subgroup */
 /* for repetitive call functions */
int FAR PASCAL nextsign (void);
 /* positioning in the next sign */
int FAR PASCAL signid (uparam);
 /* uparam: sign id number (returned) */
int FAR PASCAL signname (sparam);
 /* sparam: sign name (returned) */

 /* signs dependencies (Net) */
 /* ------------------------ */
int FAR PASCAL signdepinfo (sparam, uparam, uparam, cparam, cparam);
 /* params: sign name, layer number from initial and final signs, number of ke, number of clause (returned) */
 /* repetitive call function */
int FAR PASCAL firstoriginsign (void);
 /* positioning in the first origin sign following dependency net (layer 0) */
 /* for repetitive call functions */
int FAR PASCAL nextoriginsign (void);
 /* positioning in the next origin sign */
 /* for repetitive call functions */
int FAR PASCAL originsign (sparam, uparam);
 /* sparam: sign name, uparam: sign id number (both returned) */
 /* repetitive call function */
int FAR PASCAL firstfinalsign (void);
 /* positioning in the first final sign following dependency net (layer n) */
 /* for repetitive call functions */
int FAR PASCAL nextfinalsign (void);
 /* positioning in the next final sign */
int FAR PASCAL finalsign (sparam, uparam);
 /* sparam: sign name, uparam: sign id number (both returned) */
int FAR PASCAL firstnowsign (void);
 /* positioning in the first now-dependent sign following dependency net (layer 0) */
 /* for repetitive call functions */
int FAR PASCAL nextnowsign (void);
 /* positioning in the next now-dependent sign */
int FAR PASCAL nowsign (sparam, uparam);
 /* sparam: sign name, uparam: sign id number (both returned) */

 /* dependencies by arc */
 /* type of dependency */
#define PREV 2
#define TIME 4
#define CYCLE 8

int FAR PASCAL firstbackdep (sparam);
 /* sparam: sign name */
 /* positioning in the first backwards dependency of sign */
 /* for repetitive call functions */
int FAR PASCAL firstbackdepbyid (unsigned int);
 /* unsigned int: signid */
 /* positioning in the first backwards dependency of sign */
int FAR PASCAL nextbackdep (sparam);
 /* sparam: sign name */
 /* positioning in the next back dependency */
int FAR PASCAL nextbackdepbyid (unsigned int);
 /* unsigned int: signid */
 /* positioning in the next back dependendy of sign */
int FAR PASCAL backdepsignid (sparam, uparam);
 /* sparam: sign name, uparam: sign id number (returned) */
int FAR PASCAL backdepbyidsignid (unsigned int, uparam);
 /* unsigned int: signid, uparam: sign id number (returned) */
int FAR PASCAL backdepsignname (sparam, sparam);
 /* sparam: sign name, sparam: dependency sign name (returned) */
int FAR PASCAL backdepbyidsignname (unsigned int, sparam);
 /* unsigned int: signid, sparam: dependency sign name (returned) */
int FAR PASCAL backdepinfo (sparam, uparam, uparam, cparam, cparam);
 /* params: sign name, layer number from initial and final signs, type of dependency, number of clause (returned) */
int FAR PASCAL backdepbyidinfo (unsigned int, uparam, uparam, cparam, cparam);
 /* unsigned int: signid, layer number from initial and final signs, type of dependency, number of clause (returned) */

int FAR PASCAL firstforwdep (sparam);
 /* sparam: sign name */
 /* positioning in the first forwards dependency of sign */
 /* for repetitive call functions */
int FAR PASCAL firstforwdepbyid (unsigned int);
 /* unsigned int: signid */
 /* positioning in the first forwards dependency of sign */
int FAR PASCAL nextforwdep (sparam);
 /* sparam: sign name */
 /* positioning in the next forw dependency */
int FAR PASCAL nextforwdepbyid (unsigned int);
 /* unsigned int: signid */
 /* positioning in the next forw dependendy of sign */
int FAR PASCAL forwdepsignid (sparam, uparam);
 /* sparam: sign name, uparam: sign id number (returned) */
int FAR PASCAL forwdepbyidsignid (unsigned int, uparam);
 /* unsigned int: signid, uparam: sign id number (returned) */
int FAR PASCAL forwdepsignname (sparam, sparam);
 /* sparam: sign name, sparam: dependency sign name (returned) */
int FAR PASCAL forwdepbyidsignname (unsigned int, sparam);
 /* unsigned int: signid, sparam: dependency sign name (returned) */
int FAR PASCAL forwdepinfo (sparam, uparam, uparam, cparam, cparam);
 /* params: sign name, layer number from final and initial signs, type of dependency, number of clause (returned) */
int FAR PASCAL forwdepbyidinfo (unsigned int, uparam, uparam, cparam, cparam);
 /* params: original signid, layer number from final and initial signs, type of dependency, number of clause (returned) */


 /* papers */
 /* ------ */
int FAR PASCAL loadpapers (void);
 /* return 1 OK, else error and error message */
int FAR PASCAL papersnew (void);
 /* when papers are created */
 /* return 1 OK, else error message */


 /* papers definition */
 /* ---------------- */
#define PTRBMP 3
#define PTRTPL 6
#define PTRDLG 3
/*#define OTHER 5*/

#define PICON 0
#define PNAME 1

/*#define VALUES 2
#define VKECOM 3
#define KECOM 4
#define OTHER 5
#define VKE 6
#define KE 7*/
#define ZONETYPE 8
#define ZONEFLAG 9

#define MAXPSLOT 7
#define MINPSLOT 0

#define MAXZSLOT 8
#define MINZSLOT 0

 /* zone types */
#define ZONETITLE '\000'
#define ZONETXT '\000'
#define ZONELINEH '\001'
#define ZONELINEV '\002'
#define ZONERECT '\003'
#define ZONEBMP '\004'
#define ZONEGRAF '\005'
#define ZONEEXPR '\006'
#define ZONETABL '\007'

/* showing gms */
#define ZONEGMOUT '\010' /* only output */
#define ZONEGMIN '\011' /* also input allowed */
#define ZONEGMINM '\012' /* input is mandatory for this gm */
#define ZONEGMINES '\014' /* activate expert system when input new value */

#define FLAGGMVAL '\020' /* separate values */
#define FLAGGMF2 '\020' /* size is for phrase */
#define FLAGGMTWO '\040' /* two lines of text, sum with previous */
#define FLAGGMONLY '\100' /* do not show phrase, sum with previous */
#define FLAGGMNOUN '\200' /* do not show unit, sum with previous */

 /* new zone definition */
int FAR PASCAL newzonebyids (unsigned int, char, sparam, uparam);
 /* params: paper id, zonetype, zonename, zone id number (returned) */
int FAR PASCAL newzonebynames (sparam, char, sparam, uparam);
 /* params: paper name, zonetype, zonename, zone id number (returned) */
int FAR PASCAL newpaper (sparam, uparam);
 /* params: papername, pid number (returned) */

 /* modif existing paper */
int FAR PASCAL modifpaperbyid (unsigned int, char, sparam);
 /* params: pid, slotid, new content for slot */
int FAR PASCAL modifpaperbyname (sparam, char, sparam);
 /* params: papername, slotid, new content for slot */
int FAR PASCAL modifpaperglobbyid (unsigned int, char, sparam, unsigned int, unsigned int);
 /* params: pid, slotid, new content for slot, tam contents, itemnumber */

 /* delete paper */
int FAR PASCAL deletepaperbyid (unsigned int);
 /* params: paperid */

 /* modif existing zone */
int FAR PASCAL modifzonebyid (unsigned int, unsigned int, char, sparam);
 /* params: pid, zid, slotid, new content for slot */
int FAR PASCAL modifzonebyname (unsigned int, sparam, char, sparam);
 /* params: pid, zonename, slotid, new content for slot */
int FAR PASCAL modifzoneglobbyid (unsigned int, unsigned int, char, sparam, unsigned int, unsigned int);
 /* params: pid, zid, slotid, new content for slot, tam contents, itemnumber */

 /* delete zone */
int FAR PASCAL deletezonebyid (unsigned int,unsigned int);
 /* params: paperid, zone id number */
int FAR PASCAL deletezonebyname (unsigned int, sparam);
 /* params: paperid, zonename */

 /* save papers file */
int FAR PASCAL savepapers (void);
 /* no params */
int FAR PASCAL revisepapers (void);
 /* no params */

 /* paper lookup */
 /* ------------- */
/*#define PICON 0
#define PNAME 1

#define MAXPSLOT 7
#define MINPSLOT 0*/
 /* paper contents */
int FAR PASCAL getpaperbyid (unsigned int, char, sparam);
 /* params: pid, slotid, content for slot (returned) */
 /* extended paper contents */
int FAR PASCAL getextpaperbyid (unsigned int, char, char, sparam);
 /* params: paper pid, slotid, extslotid, content for slot (returned) */

 /* defined info of a paper */
#define PAPERID 0
#define SHOWFLAG 5
#define ZONECONTROLID 4
/*#define GROUPID 1
#define SUBGROUPID 2
#define VALUESNUM 3
#define VALUESMAX 4
#define VALUESFLAG 5
#define KENUM 6
#define OTHERNUM 7*/
#define OTHERSIZE 10

#define MAXPINFO 8
#define MINPINFO 0
#define MINCONTROLID 100

/*#define VCONSIST 1
#define VDEFAULT 64*/

 /* paper info */
int FAR PASCAL paperinfobyid (unsigned int, char, uparam);
 /* params: pid, infoid, value (returned) */
int FAR PASCAL paperinfobyname (sparam, char, uparam);
 /* params: pname, infoid, value (returned) */

int FAR PASCAL firstpaper (void);
 /* positioning in the first paper */
 /* for repetitive call functions */
int FAR PASCAL nextpaper (void);
 /* positioning in the next paper */
 /* for repetitive call functions */
int FAR PASCAL paperid (uparam);
 /* uparam: paper id number (returned) */
int FAR PASCAL papername (sparam);
 /* sparam: paper name (returned) */


 /* zones of papers */
 /* --------------- */
/*#define PICON 0
#define PNAME 1

#define VALUES 2
#define VKECOM 3
#define KECOM 4
#define OTHER 5
#define VKE 6
#define KE 7*/

/*#define MAXZSLOT 7
#define MINZSLOT 0*/
 /* zone contents */
int FAR PASCAL getzonebyid (unsigned int, unsigned int, char, sparam);
 /* params: paper pid, zoneid slotid, content for slot (returned) */
 /* extended zone contents */
int FAR PASCAL getextzonebyid (unsigned int, unsigned int, char, char, sparam);
 /* params: paper pid, zoneid, slotid, extslotid, content for slot (returned) */
 /* defined info of a zone */
#define ZONEID 2
/*#define PAPERID 0
#define GROUPID 1
#define VALUESNUM 3
#define VALUESMAX 4
#define VALUESFLAG 5
#define KENUM 6
#define OTHERNUM 7
#define OTHERSIZE 10
#define ZONETYPE 8
#define ZONEFLAG 9*/
int FAR PASCAL zoneinfobyid (unsigned int, unsigned int, char, uparam);
 /* params: pid, zoneid, infoid, value (returned) */
int FAR PASCAL zoneinfobyname (unsigned int, sparam, char, uparam);
 /* params: pid, zonename, infoid, value (returned) */
 /* set zone info */
int FAR PASCAL setzoneinfobyid (unsigned int, unsigned int, char, unsigned int);
 /* params: pid, zoneid, infoid (SHOWFLAG or ZONECONTROLID only), value */

 /* zones in a paper */
int FAR PASCAL firstzone (unsigned int);
 /* params: pid of paper */
 /* positioning in the first zone of pid paper */
 /* for repetitive call functions */
int FAR PASCAL nextzone (unsigned int);
 /* params: pid of paper */
 /* positioning in the next zone of paper */
 /* for repetitive call functions */
int FAR PASCAL zoneid (uparam);
 /* uparam: zone id number (returned) */
 /* repetitive call function */
int FAR PASCAL zonename (sparam);
 /* sparam: zone name (returned) */

 /* condition test */
int FAR PASCAL condition (unsigned int, sparam);
 /* unsigned int: subject id number */
 /* sparam: condition expression */
 /* 0: false or error, >0: true */



/* end of Header File */
