#include "all.h"

void PALInit() 
{
  char type;
  QUEUE s;
  struct Elem e;

  /* Initialize function pointers for selecting semantics mode */
  GF=GetGF(OptVal[optINFERENCE]);

  GF->Init();

  /* Initialize hash and symbol tables */
  hcreate(50);
  for (type=0;type<TYPES;type++)
  {
    stInit(&SymTables[type]);
    stInit(&SymData[type]);
  }
  stInit(&TabAct);
  stInit(&TabFlu);
  stInit(&tabRulInfo);
  
  /* Predefined constant values */
  GetNSym("false",SVALUE,&FALSE_NSym);
  GetNSym("true",SVALUE,&TRUE_NSym);
  
  /* Predefined sets */
  GetNSym("boolean",SET,&BOOLEAN_NSym);
  setEmpty(&s);
  e.Type=SVALUE; e.N.Sym=FALSE_NSym; setAddElem(&s,&e);
  e.Type=SVALUE; e.N.Sym=TRUE_NSym; setAddElem(&s,&e);
  stAddSym(&SymData[SET],(char *)s);
  
  GetNSym("event",SET,&EVENT_NSym);
  setEmpty(&s);
  e.Type=SVALUE; e.N.Sym=TRUE_NSym; setAddElem(&s,&e);
  stAddSym(&SymData[SET],(char *)s);

  BOOLEAN_RANGE=(struct Elem *)malloc(2*sizeof(struct Elem));
  BOOLEAN_RANGE[0].Type=SVALUE;
  BOOLEAN_RANGE[0].N.Sym=FALSE_NSym;
  BOOLEAN_RANGE[1].Type=SVALUE;
  BOOLEAN_RANGE[1].N.Sym=TRUE_NSym;
}

void PALDone()
{
  char type;
  QUEUE s;
  NUM i;
  struct tAtom *pa;

  /* Free hash and symbol tables */
  hdestroy();
  
  for (type=0;type<TYPES;type++)
    stFree(&SymTables[type]);
 
  stFree(&SymData[SVALUE]);
  stFree(&SymData[CONSTANT]);
  
  for (i=0;i<SymData[SET].NSym;i++) {
    s=(QUEUE)stEntry(SymData[SET],i);
    qFree(&s);
    stEntry(SymData[SET],i)=NULL;
  }
  stFree(&SymData[SET]);
  
  for (i=0;i<SymData[VAR].NSym;i++)
    free(((struct tVar *)stEntry(SymData[VAR],i))->Range);
  stFree(&SymData[VAR]);

  for (i=0;i<TabAct.NSym;i++)
  {
    pa=(struct tAtom *)stEntry(TabAct,i);
    if (pa->pcktuple) free(pa->pcktuple);
    free(pa->data);
  }
  stFree(&TabAct);
  
  for (i=0;i<TabFlu.NSym;i++)
  {
    pa=(struct tAtom *)stEntry(TabFlu,i);
    if (pa->pcktuple) free(pa->pcktuple);
    if (pa->data) free(pa->data);
  }
  stFree(&TabFlu);
  stFree(&tabRulInfo);

  free(BOOLEAN_RANGE);
}

int PALParseFile(char *fName)
{
  FILE *File;
  if ((File=fopen(fName,"r"))==NULL) 
    return 0;
  yyrestart(File);
  yyparse();  
  return 1;
}

void PALRestart()
{
  GF->Restart();
}

int PALInitial(NUM f,NUM v)
{
  return GF->TreatInit(f,v);
}

void PALEndInitial()
{
  GF->EndInits();
}

int PALAssign(NUM a,NUM v)
{
  return GF->TreatAssign(a,v);
}

int PALNewTrans()
{
  return GF->NewTrans();
}

int PALGetValue(NUM n,char Type,NUM *v,char *isPert)
{
  GF->GetValue(n,Type,v,isPert);
}

