/*****************************************************************************/
/*                                                                           */
/* Module:  palmc.c                                                          */
/* $VER:    1.0                                                              */
/* Date:    15-3-200                                                         */
/* Author:  Mario Otero Diaz						     */
/*                                                                           */
/*****************************************************************************/
/* Inlcudes*/
#include "all.h"
/*#include "palmc.h"*/
#include <stdio.h>
#include <sys/stat.h>
#include "mc.h"   	/* Include file of Medtool Connection Classic */
#include "mce.h"  	/* Extended Medtool Connection Classic for logging */
#include "mcio.h"   /* Medtool Connection Classic I/O for logging */

#ifndef unix   
#include <io.h>       
#include <dos.h>             
#include <direct.h>
#endif

#define ALREADY '\x40'

/* Constant definition */
const char *defaultgroup="a_group";
const char *defaultsubgroup ="a_subgroup";
/* Variable definition */
char mederror[512];   	/*returned medtool errors*/
char medioerror[512]; 	/*returned input/output medtool errors*/
struct expsys		/*expert system information data*/
{
        char            es_name[32];
        char            es_username[32];
        char            es_designname[32];
        char            es_userpass[32];
        char            es_designpass[32];
        char            es_author[64];
        char            es_org[64];
        char            es_date[64];
        char            es_version[64];
} expsysinfo={"palES","paluser","paldesigner","userpass","designerpass","PAL","AI LAB",__DATE__,"No version info"};
char a[20]; 		/*for passing arguments to medtool */ 
char b[20];		/*for passing arguments to medtool */ 
char buffer1[4096];/*for passing arguments to medtool */ 
char buffer2[4096];/*for passing arguments to medtool */ 
char buffer3[4096];/*for passing arguments to medtool */ 
char buffer4[4096];/*for passing arguments to medtool */ 
unsigned char flag;	   /*for passing arguments to medtool */ 
double buffer_number1;/*for passing arguments to medtool */ 
unsigned char text_buffer[4096]; /*Generic buffer*/
unsigned int optionuse=SAVEDATA; /*option for infering*/
unsigned int optiontrace;
unsigned int q;		/*for passing arguments to medtool */ 
unsigned int currentsubject; /* Current subject */
int medtoolopened = 0;  /*Is medtool already opened?*/
int OneSubjectOpened=0; /*Is There one subject opened?*/
int inputdatasituation=0; /*are We in new data situation?*/
time_t wnowtime; /* for times */

/*--------------------------------------------------------------*/
/* PrintError : Shows a error message.                          */ 
/*--------------------------------------------------------------*/
void PrintMedError(char *err_msg)
{ 
        printf("MEDTOOL CONNECTION ERROR: %s.\n", err_msg); 
}

/*--------------------------------------------------------------*/
/* RemoveOldFiles : Deletes old medtool generated files.        */
/*--------------------------------------------------------------*/
void RemoveOldFiles(void)
{

#ifdef WIN
#define munlink _unlink
#endif
#ifdef UNIX
#define munlink unlink
#endif

	sprintf(text_buffer,"%1.8s.k",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.kk",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.kkk",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.usr",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/dh",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/00000001.s/fb",expsysinfo.es_name);
	munlink(text_buffer);		
	sprintf(text_buffer,"%1.8s.db/00000002.s/fb",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/00000003.s/fb",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/00000005.s/fb",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/00000000.s/fb",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"%1.8s.db/00000000.s",expsysinfo.es_name);
	munlink(text_buffer);
	sprintf(text_buffer,"usr");
	munlink(text_buffer);
	
}
/*--------------------------------------------------------------*/
/* OpenMedtool : Initialize medtool and open de expert system.  */
/*--------------------------------------------------------------*/
int OpenMedtool(void)
{
	int id;

	/* pass string for returned error */
	if (mcerror((MCError)mederror) != 1)
	{  
		PrintMedError(mederror);
		exit(1);
	}
	printf("Using Medtool Connection Classic %s.\n\n", mederror);
 	 
	/* internal logg */
	mclogginternal(0);
	mcioerror ((MCError)medioerror);

	RemoveOldFiles();
	strcpy(text_buffer, expsysinfo.es_designpass);
 	if ( ! medtoolnew((sparam)expsysinfo.es_name,
		       (sparam)expsysinfo.es_designname, (sparam)expsysinfo.es_designpass, 
		          (sparam)expsysinfo.es_username, (sparam)expsysinfo.es_userpass))
	{
		PrintMedError(mederror);
		printf("nuevo\n\n");
 		exit(1);
	}

  
  	if (! setesinfo((sparam)expsysinfo.es_author, (sparam)expsysinfo.es_org, (sparam)expsysinfo.es_date, 
				(sparam)expsysinfo.es_version, (sparam)text_buffer))
		PrintMedError(mederror);

	/* define a group and a subgroup*/
	strcpy(a,defaultgroup);
	if (!newgroup((sparam)a, (uparam)&id))
		PrintMedError(mederror);
	strcpy(b, defaultsubgroup);
	if (!newsubgroup((sparam)a, (sparam)b, (uparam)&id))
		PrintMedError(mederror);
	

	medtoolopened = 1;
	return 0;
	
}

/*--------------------------------------------------------------*/
/* OpenOneSubject : Open One Subject or Create it if don't exist*/
/*--------------------------------------------------------------*/
int OpenOneSubject(unsigned int *idsub)
{
	if (medtoolopened == 0)
		OpenMedtool();
		
	if (!subjects((uparam) &q))
	{
		PrintMedError(mederror);
		return -1;
	}
	
	if (q)
	{
		
		if(!firstsubject())
		{
			PrintMedError(mederror);
			return -1;
		}		
		if(!subjectid((uparam) &q))
		{
			PrintMedError(mederror);
			return -1;
		}
	}
	if (!q)
	{
		mclogginternal(0);
		if(!creatsubject((uparam) &q))
		{
			PrintMedError(mederror);
			return -1;
		}
		mclogginternal(0);
		if(!subjects((uparam) &q))
		{
			PrintMedError(mederror);
			return -1;
		}
	}
	else
	{
		q=1;
		if(!opensubject((unsigned int) q))
		{
			PrintMedError(mederror);
			return -1;
		}
	}
	
	OneSubjectOpened=1;
	(*idsub)=q;
	return 0;
}
/*--------------------------------------------------------------*/
/* Reset : Create a new Subject and set as default	        */
/*--------------------------------------------------------------*/
int ResetES(void)
{
	if (medtoolopened == 0)
		OpenMedtool();
		
	if (OneSubjectOpened)
		closesubject(currentsubject);
	mclogginternal(0);
	if(!creatsubject((uparam) &q))
	{
		PrintMedError(mederror);
		return -1;
	}
	mclogginternal(0);
	if(!subjects((uparam) &q))
	{
		PrintMedError(mederror);
		return -1;
	}
		
	OneSubjectOpened=1;
	currentsubject=q;
	return 0;
}
/*--------------------------------------------------------------*/
/* CreateMG : Adds a mg in the Medtool expert system.           */
/*--------------------------------------------------------------*/
int CreateMG(char *mg_name,int atom_type)
{
	static int mg_id = 0;
 
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)
		OpenMedtool();
  	strcpy(buffer1,mg_name);
	strcpy(buffer2,defaultgroup);
	strcpy(buffer3,defaultsubgroup);
	if (atom_type==FLUENT)
		strcpy(buffer4,"FLUENT");
	else
		strcpy(buffer4,"ACTION");
	/* 2. Check if MG already exist. */
	if (! signinfobyname(buffer1, SIGNID, &mg_id))
	{
		if (!newsignbynames((sparam)buffer2, (sparam)buffer3, NUMBER, (sparam)buffer1, (uparam)&mg_id))
		{ 
			PrintMedError(mederror);
 			return -1;
		}
		if (!modifsignbyname((sparam) buffer1,(char)PHRASE,(sparam) buffer4))
		{
			PrintMedError(mederror);
 			return -1;		
		}
		
	}
	return 0;
}

/*--------------------------------------------------------------*/
/* AddKM : Adds a km to a mg.			                */
/*--------------------------------------------------------------*/
int AddKM(char *mg_name,char *km_text)
{
	static int mg_id = 0;
 
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)
		OpenMedtool();
		
  	strcpy(buffer1,mg_name);
	strcpy(buffer2,km_text);
	/* 2. Check if MG already exist. */
	if (signinfobyname(buffer1, SIGNID, &mg_id))
	{
		if (buffer2[0])
		if (!modifsignbyname((sparam) buffer1,(char)KE,(sparam) buffer2))
		{
			PrintMedError(mederror);
 			return -1;		
		}
	}
	return 0;
}
/*--------------------------------------------------------------*/
/* AddMGInitValue: set initial value for a gm			*/
/*--------------------------------------------------------------*/
int AddMGInitValue(char *mg_name,double mg_value)
{

 
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)	
		OpenMedtool();
		 
  	strcpy(buffer1,mg_name);
  	sprintf(buffer2,",[%e]",mg_value);
	/* 3. Put MG Value. */
	if (!modifsignbyname((sparam) buffer1,(char)VALUES,(sparam) buffer2))
	{
		PrintMedError(mederror);
 		return -1;		
	}
	if (!savees())
		PrintMedError(mederror);
	return 0;	
}
/*--------------------------------------------------------------*/
/* SavesES : saves Changes to the expert system 		*/
/*--------------------------------------------------------------*/
int SaveES(void)
{
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)
		return -1;
	optiontrace=0;/*(CYCLES|INFERED|IGNORED|PERTINENT|CHAIN|DETAIL);	*/

#ifdef WIN
	if (!mcloggparam((HWND)hwnd,(unsigned int)IDC_EDIT,(sparam)loggstr)						PrintMedError(mederror);
#endif
	if (!mctracelevel((unsigned int)optiontrace))
		PrintMedError(mederror);
	
	/*mclogginternal(1);*/
	if (!revisees())
		PrintMedError(mederror);
	
	if (!savees())
		PrintMedError(mederror);
	if (!OneSubjectOpened)
		OpenOneSubject(&currentsubject);	
	return 0;
}

/*--------------------------------------------------------------*/
/* PutInNewData : Put in input data situation.			*/
/*--------------------------------------------------------------*/
int PutInNewDataSituation(void)
{
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)	
		OpenMedtool();
	/* 2. Open one subject if closed. */
	if (OneSubjectOpened==0)
		OpenOneSubject(&currentsubject);
	wnowtime=0;
	inputdatasituation=1;
	if (!newdatabegin((unsigned int) currentsubject,(lparam) &wnowtime))
	{
		PrintMedError(mederror);
		return -1;
	}
	return 0;
}


/*--------------------------------------------------------------*/
/* PutMGValue: input data for a gm in the expert system.       */
/*--------------------------------------------------------------*/
int PutMGValue(char *mg_name,double mg_value)
{
	
 
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)	
		OpenMedtool();
	/* 2. Open one subject if closed. */
	if (OneSubjectOpened==0)
		OpenOneSubject(&currentsubject);

	/* 3.Prepare to input data if don't. */
	if (inputdatasituation==0)
		PutInNewDataSituation();
		 
  	strcpy(buffer1,mg_name);
  	buffer_number1=mg_value;
	/* 3. Put MG Value. */
	if (!newdataname((unsigned int) currentsubject, (sparam)buffer1, (double)buffer_number1,(sparam)buffer2))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	flag=1;
	if (!locksignbyname((sparam)buffer1,(char)LOCKEDIT,(char)ALREADY,(char)flag))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	return 0;
		
}

/*--------------------------------------------------------------*/
/*  FireTrans: call to infer 				        */
/*--------------------------------------------------------------*/
int FireTrans(void)
{
	if (!lockclearall((char)LOCKEDIT))
	{
		PrintMedError(mederror);
		return -1;
	}
	if( !(infer((unsigned int) currentsubject,(unsigned int)(optionuse|SAVEDATA|USENET))))
	{
		PrintMedError(mederror);
		return -1;
	}
	inputdatasituation=0;
	mclogginternal(0);
	return 0;
	
}
/*--------------------------------------------------------------*/
/* ShowPertinents								*/
/*--------------------------------------------------------------*/
int ShowPertinents(void (*show)(char *))
{
	/* get data */
	if (!firstnewdata((unsigned int) currentsubject))
	{
		PrintMedError(mederror);
		return -1;
	}
	
	while (nextnewdata((unsigned int) currentsubject)==1)
	{
		strcpy (buffer1,"");
		if(!getnewdataname((unsigned int) currentsubject, (sparam)buffer2, (dparam)&buffer_number1,(sparam)buffer1 ))
		{
			PrintMedError(mederror);
			return -1;
		}
		show(buffer2);
		
	}
	return 0;
}
/*--------------------------------------------------------------*/
/* GetMGValue: get data for a gm in the expert system.       */
/*--------------------------------------------------------------*/
int GetMGValue(char *mg_name,double *mg_value)
{
	
 
	/* 1. Open Medtool if closed. */
	if (medtoolopened == 0)	
		OpenMedtool();
	/* 2. Open one subject if closed. */
	if (OneSubjectOpened==0)
		OpenOneSubject(&currentsubject);
		 
  	strcpy(buffer1,mg_name);
  	
	if (GetMGUnknownValue(buffer1))
	{
		(*mg_value=-1);
		return -1;
	}
	/* 3. Put MG Value. */
	if (!getdataname((unsigned int) currentsubject, (sparam)buffer1, (dparam)&buffer_number1,(sparam)buffer2))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	(*mg_value)=buffer_number1;	
	return 0;
}

/*--------------------------------------------------------------*/
/* GetMGUnknownValue: get unknown value for a gm 		*/
/*--------------------------------------------------------------*/
int GetMGUnknownValue(char *mg_name)
{
	strcpy(buffer1,mg_name);
	if (!testsignbyname((sparam)buffer1,(char)LOCKEVAL,(char)I,(cparam)&flag))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	if (flag)
		return 1;
	else
		return 0;
		
}

/*--------------------------------------------------------------*/
/* GetMGPertinentValue: get unknown value for a gm 		*/
/*--------------------------------------------------------------*/
int GetMGPertinentValue(char *mg_name)
{
	strcpy(buffer1,mg_name);
	if (!testsignbyname((sparam)buffer1,(char)LOCKEVAL,(char)N,(cparam)&flag))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	if (flag)
		return 0;
	else
		return 1;
		
}

/*--------------------------------------------------------------*/
/* GetMGExternalValue: get unknown value for a gm 		*/
/*--------------------------------------------------------------*/
int GetMGExternalValue(char *mg_name)
{
	strcpy(buffer1,mg_name);
	if (!testsignbyname((sparam)buffer1,(char)LOCKEVAL,(char)D,(cparam)&flag))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	if (flag)
		return 1;
	else
		return 0;
		
}

/*--------------------------------------------------------------*/
/* GetMGType: get unknown value for a gm 		*/
/*--------------------------------------------------------------*/
int GetMGType(char *mg_name)
{
	strcpy(buffer1,mg_name);
	if (!getsignbyname((sparam)buffer1,(char)PHRASE,(sparam)&buffer2))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	if (strcmp(buffer2,"FLUENT")==0)
		return FLUENT;
	else
		return ACTION;
		
}

/*--------------------------------------------------------------*/
/* AlreadyInputMG: Has alerady Input been the MG calue  	*/
/*--------------------------------------------------------------*/
int AlreadyInputMG(char *mg_name)
{
	strcpy(buffer4,mg_name);
	if (!testsignbyname((sparam)buffer1,(char)LOCKEDIT,(char)ALREADY,(cparam)&flag))
	{ 
		PrintMedError(mederror);
 		return -1;
	}
	if (flag)
		return 1;
	else
		return 0;
		
}
