#include "all.h"
/*
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sstack.h"
*/
#define BOTTOM(s) ((s)[0].prev)
#define TOP(s) ((s)[0].next)

int ssInit(SSTACK *s,POS size)
{
  POS i;
  if ( ((*s)=(SSTACK)calloc(sizeof(SSNODE),size+1))==NULL) return 0;
  for (i=0;i<=size;i++) {
    (*s)[i].next=0;		
    (*s)[i].prev=0;
  }
  return 1;
}

int ssSequentialFill(SSTACK s,POS num)
{
  POS i;
  SSTACK t;
  
  if (!ssISEMPTY(s)||num==0) return 0;
  TOP(s)=1;
  t=s+1;
  t->prev=0;
  for (i=2;i<=num;i++) { 
    t->next=i;
    t++;
    t->prev=i-1;
  }
  t->next=0;
  BOTTOM(s)=num;
  return 1;
}

int ssPush(SSTACK s,POS e)
{
  e++;
  /* If already included return 0 */
  if (TOP(s)==e||s[e].next||s[e].prev) return 0;
  
  if (ssISEMPTY(s)) {
    TOP(s)=e;
    BOTTOM(s)=e;
  }
  else {
    s[TOP(s)].prev=e;
    s[e].prev=0;
    s[e].next=TOP(s);
    TOP(s)=e;  
  }
  return 1;
}

int ssPop(SSTACK s)
{
  POS t;
  
  /* If empty, return 0 */
  if (ssISEMPTY(s)) return 0;
  
  t=TOP(s);
  TOP(s)=s[t].next;		/* top is the next element */
  s[t].next=0; s[t].prev=0;     /* mark element as deleted */
  if (TOP(s)==0)		/* if it becomes empty */
    BOTTOM(s)=0;		  /* mark bottom=0 */
  else
    s[TOP(s)].prev=0;		  /* top element has not previous */
  return 1;
}

int ssInsertLast(SSTACK s,POS e)
{
  e++;
  /* If already included return 0 */
  if (TOP(s)==e||s[e].next||s[e].prev) return 0;

  if (ssISEMPTY(s)) {
    TOP(s)=e;
    BOTTOM(s)=e;
  }
  else {
    s[BOTTOM(s)].next=e;
    s[e].next=0;
    s[e].prev=BOTTOM(s);
    BOTTOM(s)=e;  
  }
  return 1;
}

int ssDelete(SSTACK s,POS e)
{
  e++;
  /* If empty or not included, return 0 */
  if (ssISEMPTY(s)||(!s[e].next&&!s[e].prev&&TOP(s)!=e)) return 0;

  /* If on top, then simply pop */
  if (TOP(s)==e) 
    ssPop(s);
  else {
    if (BOTTOM(s)==e)
      BOTTOM(s)=s[e].prev;
    s[s[e].prev].next=s[e].next;
    if (s[e].next!=0)
      s[s[e].next].prev=s[e].prev;
    s[e].next=0;
    s[e].prev=0;
  }
  
  return 1;
}

int ssMoveTop(SSTACK s,POS e)
{
  if (!ssDelete(s,e)) return 0;
  ssPush(s,e);
}

int ssMoveBottom(SSTACK s,POS e)
{
  if (!ssDelete(s,e)) return 0;
  ssInsertLast(s,e);
}

int ssShow(SSTACK s)
{
  POS t;
  
  for(t=TOP(s);t!=0;t=s[t].next)
    printf("%d ",t-1);
}
